'From Squeak 2.0 BETA of May 8, 1998 on 8 May 1998 at 7:40:25 pm'!

!EToySystem class methodsFor: 'development support' stamp: 'sw 5/8/1998 19:40'!
prepareForExternalReleaseNamed: aReleaseName
	"EToySystem prepareForExternalReleaseNamed: '2.0Beta'"

	self stripMethodsForExternalRelease.

	EToySystem class compile: 'guessDOLProxy
	"deleted for external release"' classified: 'stripped'.

	ScriptingSystem saveFormsToFileNamed: aReleaseName, '.Dis.Forms'.
	self stripGraphicsForExternalRelease.
	ScreenController initialize! !

!EToySystem class methodsFor: 'development support' stamp: 'sw 5/8/1998 19:28'!
stripGraphicsForExternalRelease
	"EToySystem stripGraphicsForExternalRelease"

	| aDict replacement |
	aDict _ ScriptingSystem formDictionary.
	replacement _ aDict at: 'Gets'.

	#('BadgeMiniPic' 'BadgePic' 'Broom' 'CedarPic' 'CollagePic' 'CoverSpiral' 'CoverTexture' 'Fred' 'ImagiPic' 'KayaPic' 'StudioPic')
		do:
			[:aKey | aDict at: aKey put: replacement]! !

!EToySystem class methodsFor: 'development support' stamp: 'sw 5/8/1998 19:28'!
stripMethodsForExternalRelease
	"EToySystem stripMethodsForExternalRelease"

	Utilities stripMethods: self methodsToStripForExternalRelease messageCode: '2.0BetaExternal'! !

!EToySystem class methodsFor: 'external release' stamp: 'sw 5/8/1998 19:26'!
methodsToStripForExternalRelease
	"Answer a list of triplets #(className, class/instance, methodName) of methods to be stripped in an external release."
	^ #(
		(EToyHolder			instance	initializeScaffoldingContentsForFreshEToy)
		(EToyHolder			instance	cedarText)
		(EToyHolder			instance	kayaText)
		(EToyHolder			instance	scaffoldingImagineersStrings)

		(EToyParameters		instance	initializein:)

		(EToyPlayer			instance	initializeFor:inWorld:)
		(EToyPlayer			class		openFrontCoverFor:)

		(EToySystem			class		serverUrls)
		(EToySystem			class		eToyDoItStrings)
		(EToySystem			class		loadPurpleWalt)	
		(EToySystem			class		openImagineeringStudio)	
		(EToySystem			class		readCollagePic)	
		(EToySystem			class		prepareRelease)	
		(EToySystem			class		previewEToysOn:)

		(EToyWorld			instance	createFrontCover)
		(EToyWorld			instance	exitFromCover)
		(EToyWorld			instance	scanServerForEToys)

		(ScreenController	class		initializeOpenMenuForInternalUse)
		(ScreenController	instance	openImagineeringStudio)
		(ScreenController	instance	openEToy)
		(ScreenController	instance	openEToyPanel)
		)! !


EToySystem class removeSelector: #stripDisneyGraphicsForExternalRelease!
EToySystem class removeSelector: #stripDisneyMethodsForExternalRelease!
