'From Squeak 2.0 of May 22, 1998 on 28 May 1998 at 1:29:25 pm'!
"Change Set:		FixesForIan-di
Date:			27 May 1998
Author:			Dan Ingalls

Two fixes requested by Ian Piumarta:
Provide a context menu for the Transcript and Workspaces in Morphic.
Make reframing of ProjectViews work right.

Plus a couple of others...
Enables the volume menu in FileLists in morphic.
Causes primitive string display (as in 'abc' displayAt: 0@0) to be black on white.
	[It had been black on transparent and all black in 16 bits.
	Very hard to read the primitive debugger then]
"!


!Object methodsFor: 'private' stamp: 'di 5/28/1998 12:50'!
primitiveError: aString 
	"This method is called when the error handling results in a recursion in calling
	on error: or halt or halt:."
	| context |
	(String streamContents:
		[:s |
		s nextPutAll: '**System error handling failed** '.
		s cr; nextPutAll: aString.
		context _ thisContext sender sender.
		20 timesRepeat: 
			[context == nil ifFalse: [s cr; print: (context _ context sender)]].
		s cr; nextPutAll: '**Type any character to restart.**'])
		displayAt: 0@0.
	[Sensor keyboardPressed] whileFalse.
	Sensor keyboard.
	Smalltalk isMorphic ifTrue:
		[^ World install "To init hand events and redisplay world"].
	ScheduledControllers searchForActiveController! !


!ProjectView methodsFor: 'displaying' stamp: 'di 5/27/1998 16:58'!
displayView
	super displayView.
	self label = model name
		ifFalse: [super relabel: model name].
	self isCollapsed ifTrue: [^ self].
	model thumbnail ifNil: [^ self].
	self insetDisplayBox extent = model thumbnail extent
		ifTrue: [model thumbnail displayAt: self insetDisplayBox topLeft]
		ifFalse: [(model thumbnail
					magnify: model thumbnail boundingBox
					by: self insetDisplayBox extent asFloatPoint / model thumbnail extent) 				displayAt: self insetDisplayBox topLeft]
! !


!ProjectViewMorph methodsFor: 'all' stamp: 'di 5/27/1998 20:47'!
extent: aPoint
	"Set my image form to the given extent."
	| newExtent scaleP scale fillColor |
	((bounds extent = aPoint) and:
	 [image depth = Display depth]) ifFalse: [
		lastProjectThumbnail
			ifNil: [newExtent _ aPoint]
			ifNotNil: [
				scaleP _ aPoint / lastProjectThumbnail extent.
				scale _ scaleP "scaleP x asFloat max: scaleP y asFloat".
				newExtent _ (lastProjectThumbnail extent * scale) rounded].
		self image: (Form extent: newExtent depth: Display depth).
		project world
			ifNil: [fillColor _ Color veryLightGray]
			ifNotNil: [fillColor _ project world color].
		image fill: image boundingBox fillColor: fillColor.
		lastProjectThumbnail _ nil].
! !


!String methodsFor: 'displaying' stamp: 'di 5/28/1998 13:25'!
displayAt: aPoint 
	"Display the receiver as a DisplayText at aPoint on the display screen."

	self displayOn: Display at: aPoint! !

!String methodsFor: 'displaying' stamp: 'di 5/28/1998 13:25'!
displayOn: aDisplayMedium at: aPoint 
	"Show a representation of the receiver as a DisplayText at location
	aPoint on aDisplayMedium."

	(self asDisplayText foregroundColor: Color black backgroundColor: Color white)
		displayOn: aDisplayMedium at: aPoint! !


!StringHolder methodsFor: 'initialize-release' stamp: 'di 5/27/1998 21:21'!
openAsMorphLabel: labelString 
	"Workspace new openAsMorphLabel: 'Workspace'"
	| window |
	window _ (SystemWindow labelled: labelString) model: self.

	window addMorph: (PluggableTextMorph on: self text: #contents accept: #acceptContents:
			readSelection: nil menu: #codePaneMenu:shifted:)
		frame: (0@0 corner: 1@1).

	window openInWorld! !

!StringHolder methodsFor: 'code pane menu' stamp: 'di 5/27/1998 16:44'!
codePaneMenu: aMenu shifted: shifted
	"Note that unless we override perform:orSendTo:, PluggableTextController will respond to all menu items in a text pane"
	| shiftMenu |
	^ shifted 
	ifFalse: [aMenu 
		labels: PluggableTextController yellowButtonMenu labelString 
		lines: PluggableTextController yellowButtonMenu lineArray
		selections: PluggableTextController yellowButtonMessages]

	ifTrue: [shiftMenu _ PluggableTextController shiftedYellowButtonMenu.
		aMenu 
			labels: shiftMenu labelString 
			lines: shiftMenu lineArray
			selections: PluggableTextController shiftedYellowButtonMessages]
! !


!FileList class methodsFor: 'instance creation' stamp: 'di 5/28/1998 10:37'!
openAsMorph     "FileList openAsMorph openInMVC"
	"Open a morphic view of a FileList on the default directory."
	| dir aFileList window |
	dir _ FileDirectory default.
	aFileList _ self new directory: dir.
	window _ (SystemWindow labelled: dir pathName) model: aFileList.

	window addMorph: ((PluggableListMorph on: aFileList list: #volumeList selected: #volumeListIndex
				changeSelected: #volumeListIndex: menu: #volumeMenu:) autoDeselect: false)
		frame: (0@0 corner: 0.3@0.2).
	window addMorph: (PluggableTextMorph on: aFileList text: #pattern accept: #pattern:)
		frame: (0@0.2 corner: 0.3@0.3).
	window addMorph: (PluggableListMorph on: aFileList list: #fileList selected: #fileListIndex
				changeSelected: #fileListIndex: menu: #fileListMenu:)
		frame: (0.3@0 corner: 1@0.3).
	window addMorph: (PluggableTextMorph on: aFileList text: #contents accept: #put:
			readSelection: #contentsSelection menu: #fileContentsMenu:shifted:)
		frame: (0@0.3 corner: 1@1).
	^ window! !


!TranscriptStream methodsFor: 'all' stamp: 'di 5/27/1998 16:44'!
codePaneMenu: aMenu shifted: shifted
	"Note that unless we override perform:orSendTo:, PluggableTextController will respond to all menu items"
	^ StringHolder basicNew codePaneMenu: aMenu shifted: shifted
! !

!TranscriptStream methodsFor: 'all' stamp: 'di 5/27/1998 16:36'!
openAsMorphLabel: labelString 
	"Build a morph viewing this transcriptStream"
	| window |
	window _ (SystemWindow labelled: labelString) model: self.
	window addMorph: (PluggableTextMorph on: self text: nil accept: nil
			readSelection: nil menu: #codePaneMenu:shifted:)
		frame: (0@0 corner: 1@1).
	^ window! !

!TranscriptStream methodsFor: 'all' stamp: 'di 5/27/1998 16:36'!
openLabel: aString 
	"Open a window on this transcriptStream"
	| topView codeView |
	World ifNotNil: [^ (self openAsMorphLabel: aString) openInWorld].

	topView _ (StandardSystemView new) model: self.
	topView borderWidth: 1.
	topView label: aString.
	topView minimumSize: 100 @ 50.

	codeView _ PluggableTextView on: self text: nil accept: nil
					readSelection: nil menu: #codePaneMenu:shifted:.
	codeView window: (0@0 extent: 200@200).
	topView addSubView: codeView.
	topView controller open! !


StringHolder class removeSelector: #originalWorkspaceContents!
