'From Squeak 2.0 of May 22, 1998 on 11 June 1998 at 10:33:14 pm'!

!BookMorph methodsFor: 'menu' stamp: 'tk 6/11/1998 17:46'!
deletePage

	| message |
	message _ 'Are you certain that you
want to delete this page and all its morphs?'.
	(self confirm: message) ifTrue: 
			[self deletePageBasic].
	! !

!BookMorph methodsFor: 'menu' stamp: 'tk 6/11/1998 17:42'!
deletePageBasic

	| oldPage |
	oldPage _ currentPage.
	self nextPage.
	pages remove: oldPage.
	oldPage delete.
	currentPage = oldPage ifTrue: [self nextPage].
	pages isEmpty ifTrue: [self insertPage].
! !


!ChangeSorter methodsFor: 'changeSet menu' stamp: 'tk 6/11/1998 11:20'!
rename
	"Store a new name string into the selected ChangeSet.  reject duplicate name; allow user to back out"

	| newName |
	newName _ FillInTheBlank request: 'New name for this change set'
						initialAnswer: myChangeSet name.
	(newName = myChangeSet name or: [newName size == 0]) ifTrue:
			[^ self inform: 'No change made'].

	(self class changeSetNamed: newName) ifNotNil:
			[^ Utilities inform: 'Sorry that name is already used'].

	myChangeSet name: newName.
	self changed: #currentCngSet.	"new -- list of sets"
	self changed: #mainButtonName.
	self changed: #relabel.! !


!HTMLformatter class methodsFor: 'formatting' stamp: 'pm 6/6/1998 21:39'!
textAreaStart: fieldName rows: rows cols: cols
       ^ '<TEXTAREA NAME="', fieldName, '" ROWS=',rows,' COLS=',cols,'>' ! !


!Inspector methodsFor: 'accessing' stamp: 'tk 6/11/1998 22:23'!
trash: newText
	"Don't save it"
	^ true! !


!PaintBoxMorph methodsFor: 'actions' stamp: 'tk 6/11/1998 11:25'!
pickup: actionButton action: aSelector cursor: aCursor
	"Special version for pickup: and stamp:, because of these tests"

	| ss picker old map stamper |
	self tool: actionButton action: aSelector cursor: aCursor.

	aSelector == #stamp: ifTrue: [
		(stampHolder pickupButtons includes: actionButton) ifTrue: [
				stamper _ stampHolder otherButtonFor: actionButton.
				^ self pickup: stamper action: #stamp: cursor: (stamper arguments at: 3)].
		(stampHolder stampFormFor: actionButton) 
			ifNil: [
				"If not stamp there, go to pickup mode"
				picker _ stampHolder otherButtonFor: actionButton.
				picker state: #on.
				^ self pickup: picker action: #pickup: cursor: (picker arguments at: 3)]
			ifNotNil: [
				old _ stampHolder stampFormFor: actionButton.
				currentCursor _ ColorForm extent: old extent depth: 8.
				old displayOn: currentCursor.
				map _ Color indexedColors copy.
				map at: 1 put: Color transparent.
				currentCursor colors: map.
				currentCursor offset: currentCursor extent // 2.
				"Emphisize the stamp button"
				actionButton owner "layoutMorph" "color: (Color r: 1.0 g: 0.645 b: 0.419);"
					borderColor: (Color r: 0.65 g: 0.599 b: 0.8).
				]].

	aSelector == #pickup: ifTrue: [
		ss _ self world findA: SketchEditorMorph.
		ss ifNotNil: [currentCursor _ aCursor]	 
			ifNil: [self notCurrentlyPainting.
				self setAction: #paint:]].
! !


