'From Squeak 2.0 of May 22, 1998 on 13 June 1998 at 9:05:42 am'!
"Change Set:		jhmFileListFixesJun13
Date:			13 June 1998
Author:			John Maloney

Fixes a FileList problem with file names contain parentheses characters.
Fixes 'show image in a window' command in Morphic projects.
Fixes a bug in SystemTracer reported by Tim Rowledge (thanks, Tim!!)."!


!FileList methodsFor: 'file list menu' stamp: 'jm 6/13/1998 08:40'!
openImageInWindow
	"Handle three file formats: GIF, Form stoteOn: (run coded), and BMP. Fail if file format is not recognized."
 
	| image |
	image _ Form fromFile: (directory oldFileNamed: fileName).
	World
		ifNil: [FormView open: image named: fileName]
		ifNotNil: [World addMorph: (SketchMorph new form: image)].
! !

!FileList methodsFor: 'private'!
fileNameFromFormattedItem: item
	"Extract fileName and folderString from a formatted fileList item string"
	| i |
	(i _ item indexOf: $( ifAbsent: [0]) = 0 ifTrue: [^ item withBlanksTrimmed].
	^ (item copyReplaceFrom: i to: (item findFirst: [:c | c = $)]) with: '') withBlanksTrimmed! !


!SystemTracer methodsFor: 'initialization' stamp: 'jm 6/13/1998 08:33'!
writeFileHeader
	file position: 0.  "info in header page"
	self write4Bytes: ($A asciiValue *100) + 2.  "version number:  6500+2"
	self write4Bytes: imageHeaderSize.  "File offset (bytes) of start of data"
							"same as base address (byte) of first object"
	self write4Bytes: maxOop.  "Length of data segment in words"
	self write4Bytes: 0.		"what you have to add to an oop to get"
							"an offset in the data portion of this file"
	self write4Bytes: (self mapAt: specialObjects).
	self write4Bytes: (hashGenerator next * 16rFFF asFloat) asInteger.  "next hash"
	self write4Bytes: Display width * 16r10000 + Display height.  "display size"
	file position > imageHeaderSize ifTrue: [self error: 'Header ran over allotted length'].
	file padTo: imageHeaderSize put: 0.  "Pad header page"

	"On Mac, set the file type and creator (noop on other platforms)"
	FileDirectory default
		setMacFileNamed: self fullName
		type: 'STim'
		creator: 'FAST'.
	file close.
! !


