'From Squeak 2.4b of April 23, 1999 on 4 June 1999 at 10:32:38 am'!
"Change Set:		MiscTweaks-ar
Date:			4 June 1999
Author:			Andreas Raab

Fixes two problems:
1) Picking in Wonderlands should now work again.
2) Makes Worlds always have a non-gradient color. This was necessary because #displayWorld bypasses the regular (inherited) draw methods from GradientFillMorph resulting in a different appearance during project transitions.
"!


!B3DPickerEngine methodsFor: 'private-rendering' stamp: 'ar 6/4/1999 10:28'!
processIndexed: vb
	| idxArray vtxArray index vtx zValue minIndex minZ wValue |
	idxArray _ vb indexArray.
	vtxArray _ vb vertexArray.
	minZ _ 10.0.
	minIndex _ 0.
	1 to: vb indexCount do:[:i|
		index _ idxArray at: i.
		index = 0 ifFalse:[
			vtx _ vtxArray at: index.
			zValue _ vtx rasterPosZ.
			wValue _ vtx rasterPosW.
			wValue = 0.0 ifFalse:[zValue _ zValue / wValue].
			(minIndex = 0 or:[zValue < minZ]) ifTrue:[
				minIndex _ index.
				minZ _ zValue].
		].
	].
	^minIndex! !

!B3DPickerEngine methodsFor: 'private-rendering' stamp: 'ar 6/4/1999 10:28'!
processVertexBuffer: vb
	| minIndex minVertex minW |
	minIndex _ self primComputeMinIndexZ: vb primitive vtxArray: vb vertexArray vtxSize: vb vertexCount idxArray: vb indexArray idxSize: vb indexCount.
	minIndex == nil ifTrue:[minIndex _ super processVertexBuffer: vb].
	minIndex = 0 ifTrue:[^maxVtx].
	minVertex _ vb vertexArray at: minIndex.
	minW _ minVertex rasterPosW.
	minW = 0.0 ifFalse:[minVertex rasterPosZ: minVertex rasterPosZ / minW].
	^minVertex! !


!GradientFillMorph methodsFor: 'as yet unclassified' stamp: 'ar 6/4/1999 10:29'!
setGradientFillColor: aColor

	fillColor2 _ aColor.
! !


!WorldMorph methodsFor: 'accessing' stamp: 'ar 6/4/1999 10:28'!
color: aColor
	"Set the background color of this world."

	color = aColor ifFalse: [
		fillColor2 _ color _ aColor.
		self fullRepaintNeeded.
		"Propagate to view"
		self changed: #newColor].
! !


"Postscript:
Fix all the Worlds to have no gradient fills"
WorldMorph allInstancesDo:[:w| w setGradientFillColor: w color]!

