'From Squeak 2.5 of August 6, 1999 on 18 August 1999 at 8:25:20 am'!
"Change Set:		joystickFixes-sw
Date:			18 August 1999
Author:			Scott Wallace

Makes JoystickMorphs able to obey ticking scripts again -- a facility they lost in June 1998 evidently!!

Acceding to a request from Alan, makes Joysticks draggable by simple mouse gesture except when the mouse-down lands within the inner positioning circle"!


!JoystickMorph methodsFor: 'other' stamp: 'sw 8/14/1999 20:35'!
handlesMouseDown: evt

	self inPartsBin ifTrue: [^ false].

	(handleMorph fullContainsPoint: (handleMorph pointFromWorld: evt cursorPoint))
		ifTrue: [^ true]
		ifFalse: [^ super handlesMouseDown: evt].
! !

!JoystickMorph methodsFor: 'stepping' stamp: 'sw 8/13/1999 14:03'!
step
	"Track the real joystick whose index is realJoystickIndex."
	"Details:
	  a. if realJoystickIndex is nil we're not tracking a joystick
	  b. [-joyMax..joyMax] is nominal range of joystick in both X and Y
	  c. [-threshold..threshold] is considered 0 to compensate for poor joystick centering"

	| threshold joyMax joyPt m mCenter r scaledPt |
	super step.  "Run ticking user-written scripts if any"
	realJoystickIndex ifNil: [^ self].
	threshold _ 30.
	joyMax _ 350.
	joyPt _ Sensor joystickXY: realJoystickIndex.
	joyPt x abs < threshold ifTrue: [joyPt _ 0@joyPt y].
	joyPt y abs < threshold ifTrue: [joyPt _ joyPt x@0].
	lastRealJoystickValue = joyPt ifTrue: [^ self].
	lastRealJoystickValue _ joyPt.
	m _ handleMorph.
	mCenter _ m center.
	r _ m owner innerBounds insetBy:
		((mCenter - m fullBounds origin) corner: (m fullBounds corner - mCenter)).
	scaledPt _ r center + ((r extent * joyPt) / (joyMax * 2)) truncated.
	m position: (scaledPt adhereTo: r) - (m extent // 2).
! !

!JoystickMorph methodsFor: 'stepping' stamp: 'sw 8/13/1999 14:00'!
stepTime
	^ realJoystickIndex
		ifNil:
			[0]  "fast as we can to track actual joystick"
		ifNotNil:
			[super stepTime]
! !


