'From Squeak 2.5 of August 6, 1999 on 17 September 1999 at 2:27:07 pm'!
"Change Set:		WndlActorPivot
Date:			17 September 1999
Author:			Jeff Pierce

Adds setPivot: to WonderlandActors.  Basically this allows you to change the insertion point of an actor.  It's in the private category because it's not intended to be used by end users."!


!B3DIndexedMesh methodsFor: 'modifying' stamp: 'jsp 9/17/1999 14:13'!
transformBy: aMatrix
	"Modify the mesh by transforming it using a matrix; this allows us to change the insertion point of the mesh"

	vertices do: [:vtx | 	vtx privateLoadFrom: ((aMatrix composeWith:
										(B3DMatrix4x4 identity translation: vtx)) translation) ].

	bBox ifNotNil: [ self computeBoundingBox ].
	self computeVertexNormals.
! !


!WonderlandActor methodsFor: 'private' stamp: 'jsp 9/17/1999 14:23'!
setPivot: aVector
	"Modify the object to use the specified point as the pivot point."

	| matrix invMatrix b3dVector |

	"Check our arguments to make sure they're valid"
	[ WonderlandVerifier VerifyTarget: aVector ]
		ifError: [ :msg :rcvr |
			myWonderland reportErrorToUser: 'Squeak could not determine what pivot to use because ', msg.
			^ nil ].


	"Our parameters check out, so change the pivot"
	(aVector isKindOf: WonderlandActor)
		ifTrue: [ matrix _ aVector getMatrixFromRoot. ]
		ifFalse: [ b3dVector _ B3DVector3 x: (aVector at: 1) y: (aVector at: 2)
									z: (aVector at: 3).
				  matrix _ B3DMatrix4x4 identity translation: b3dVector ].

	"Add an undo action"
	b3dVector _ self getMatrixFromRoot translation.
	myWonderland getUndoStack push: (UndoAction new: [self setPivot: b3dVector ]).

	invMatrix _ (matrix inverseTransformation) composeWith: (self getMatrixFromRoot).

	myMesh ifNotNil: [ myMesh _ myMesh copy.
					    myMesh vertices: (myMesh vertices copy).
					    myMesh transformBy: invMatrix ].

	composite _ (myParent getMatrixToRoot) composeWith: matrix.

	(self getChildren) do: [:child | child setComposite:
										(invMatrix composeWith: (child getComposite)) ].

! !


