'From Squeak 2.5 of August 6, 1999 on 21 September 1999 at 1:16:17 pm'!
"Change Set:		BlockTemps-CL
Date:			21 September 1999
Author:			Craig Latta

Allows Squeak to read the syntax for block-local temporary variables.  However, users must be aware that the SEMANTICS are unchanged from the normal unscoped temporary variables in Squeak, so that code that relies on this scoping will not work properly.

This is merely a convenience step along the way to support of full block closures.
"!


!Encoder methodsFor: 'temps' stamp: 'crl 2/26/1999 12:18'!
bindBlockTemp: name 
	"Declare a temporary block variable; complain if it's not a field or class variable."

	| node |

	node _ scopeTable at: name ifAbsent: [^self reallyBind: name].
	node isTemp
		ifTrue: [
			node scope >= 0 ifTrue: [^ self notify: 'Name already used in this method'].
			node scope: 0]
		ifFalse: [^self notify: 'Name already used in this class'].
	^node
! !


!Parser methodsFor: 'expression types' stamp: 'crl 2/26/1999 12:22'!
temporaryBlockVariables
	"Scan and answer temporary block variables."

	| variables |

	(self match: #verticalBar) ifFalse: [
		"There are't any temporary variables."
		^#()].

	variables _ OrderedCollection new.
	[hereType == #word] whileTrue: [variables addLast: (encoder bindBlockTemp: self advance)].
	(self match: #verticalBar) ifTrue: [^variables].
	^self expected: 'Vertical bar'! !

!Parser methodsFor: 'expression types' stamp: 'crl 2/26/1999 12:25'!
blockExpression
	"[ {:var} ( | statements) ] => BlockNode."

	| variableNodes temporaryBlockVariables |

	variableNodes _ OrderedCollection new.

	"Gather parameters."
	[self match: #colon] whileTrue: [variableNodes addLast: (encoder autoBind: self argumentName)].
	(variableNodes size > 0 & (hereType ~~ #rightBracket) and: [(self match: #verticalBar) not]) ifTrue: [^self expected: 'Vertical bar'].

	temporaryBlockVariables _ self temporaryBlockVariables.
	self statements: variableNodes innerBlock: true.
	(self match: #rightBracket) ifFalse: [^self expected: 'Period or right bracket'].

	"The scope of the parameters and temporary block variables is no longer active."
	temporaryBlockVariables do: [:variable | variable scope: -1].
	variableNodes do: [:variable | variable scope: -1]! !


