'From Squeak 2.5 of August 6, 1999 on 22 September 1999 at 3:34:15 pm'!
"Change Set:		depthmenu-bf
Date:			18 September 1999
Author:			Bert Freudenberg

Changes the 'set display depth...' menu to only offer supported display depths."!


!DisplayScreen methodsFor: 'other' stamp: 'bf 9/18/1999 19:46'!
supportedDisplayDepths
	"Return all pixel depths supported on the current host platform."
	^#(1 2 4 8 16 32) select: [:d | self supportsDisplayDepth: d]! !


!HandMorph methodsFor: 'world menu commands' stamp: 'bf 9/18/1999 20:02'!
setDisplayDepth
	"Let the user choose a new depth for the display. "
	| result oldDepth |
	oldDepth _ Display depth.
	(result _ (SelectionMenu selections: Display supportedDisplayDepths) startUpWithCaption: 'Choose a display depth
(it is currently ' , oldDepth printString , ')') == nil ifFalse:
		[Display newDepth: result].
	(World isMorph and: [(Display depth < 4) ~= (oldDepth < 4)]) ifTrue:
		["Repaint windows since they look better all white in depth < 4"
		(SystemWindow windowsIn: World satisfying: [:w | true]) do:
			[:w | w updatePaneColors]]! !


!ScreenController methodsFor: 'menu messages' stamp: 'bf 9/18/1999 20:01'!
setDisplayDepth
	"Let the user choose a new depth for the display. "
	| result |
	(result _ (SelectionMenu selections: Display supportedDisplayDepths) startUpWithCaption: 'Choose a display depth
(it is currently ' , Display depth printString , ')') == nil ifFalse:
		[Display newDepth: result]! !
