'From Squeak 2.5 of August 6, 1999 [latest update: #1499] on 28 September 1999 at 8:46:51 pm'!
"Change Set:		iconicButton-sw
Date:			28 September 1999
Author:			Scott Wallace

Adds a SimpleButtonMorph subclass called IconicButton, which behaves like a SimpleButtonMorph but which shows a graphic rather than a string.  

This is in preparation for converting various textual controls over to being graphical.  Note that if you have a textual control and wish to convert to a graphical control that looks the same (as a point of departure, pending artwork), there is a simple protocol for doing this.  Evaluate, for example,
  self currentHand attachMorph: (IconicButton new labelFromString: 'Testing!!')
"!

SimpleButtonMorph subclass: #IconicButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Widgets'!

!SimpleButtonMorph methodsFor: 'initialization' stamp: 'sw 9/28/1999 14:13'!
initialize

	super initialize.
	self borderWidth: 1.
	self borderColor: #raised.
	self color: (Color r: 0.4 g: 0.8 b: 0.6).
	target _ nil.
	actionSelector _ #flash.
	arguments _ EmptyArray.
	actWhen _ #buttonUp.
	self setDefaultLabel
! !

!SimpleButtonMorph methodsFor: 'initialization' stamp: 'sw 9/28/1999 14:05'!
setDefaultLabel
	self label: 'Flash'.
! !

!SimpleButtonMorph methodsFor: 'menu' stamp: 'sw 9/28/1999 20:42'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	self addLabelItemsTo: aCustomMenu hand: aHandMorph.
	(target isKindOf: BookMorph)
		ifTrue:
			[aCustomMenu add: 'set page sound' action: #setPageSound:.
			aCustomMenu add: 'set page visual' action: #setPageVisual:]
		ifFalse:
			[aCustomMenu add: 'change action selector' action: #setActionSelector.
			aCustomMenu add: 'change arguments' action: #setArguments.
			aCustomMenu add: 'change when to act' action: #setActWhen.
			((self world rootMorphsAt: aHandMorph targetOffset) size > 1) ifTrue:
				[aCustomMenu add: 'set target' action: #setTarget:]].
! !

!SimpleButtonMorph methodsFor: 'menu' stamp: 'sw 9/28/1999 20:41'!
addLabelItemsTo: aCustomMenu hand: aHandMorph
	aCustomMenu add: 'change label' action: #setLabel
! !


!IconicButton commentStamp: 'sw 9/28/1999 14:39' prior: 0!
A "Simple Button" in which the appearance is provided by a Form.!

!IconicButton methodsFor: 'as yet unclassified' stamp: 'sw 9/28/1999 20:42'!
addLabelItemsTo: aCustomMenu hand: aHandMorph
	"don't do the inherited behavior, since there is no textual label in this case"! !

!IconicButton methodsFor: 'as yet unclassified' stamp: 'sw 9/28/1999 14:11'!
labelFromString: aString
	"Make an iconic label from aString"

	self labelGraphic: (StringMorph contents: aString) imageForm
! !

!IconicButton methodsFor: 'as yet unclassified' stamp: 'sw 9/28/1999 14:11'!
labelGraphic: aForm
	| oldLabel graphicalMorph |
	(oldLabel _ self findA: SketchMorph)
		ifNotNil: [oldLabel delete].
	graphicalMorph _ SketchMorph new form: aForm.
	self extent: graphicalMorph extent + (borderWidth + 6).
	graphicalMorph position: self center - (graphicalMorph extent // 2).
	self addMorph: graphicalMorph.
	graphicalMorph lock
! !

!IconicButton methodsFor: 'as yet unclassified' stamp: 'sw 9/28/1999 18:38'!
setDefaultLabel
	self labelGraphic: (ScriptingSystem formAtKey: 'squeakyMouse')! !


