'From Squeak 2.1 of June 30, 1998 on 10 July 1998 at 2:45:21 pm'!
"Change Set:		bookAndPianoFixes
Date:			10 July 1998
Author:			John Maloney

Fixes:
  a. page turning sound glitch
  b. space buildup
Compresses vertical size of piano roll by one pixel per key.
Adds menu items to compress/expand time scale."
!


!BookMorph methodsFor: 'zooming page turns' stamp: 'jm 7/10/1998 14:06'!
showPageTurningFeedbackFromOrigin: oldOrigin ascending: ascending

	| image |
	ascending ifNotNil: [
		image _ currentPage imageForm.  "compute image before starting sound"
		self playPageFlipSound.
		(PageFlipSoundOn and: [oldOrigin ~~ nil]) ifTrue: [
			Display wipeImage: image
				at: oldOrigin
				delta: (ascending ifTrue: [0@-4] ifFalse: [0@4])]].
! !

!BookMorph methodsFor: 'private' stamp: 'jm 7/10/1998 14:08'!
goToPage: pageNumber

	| pageIndex  oldOrigin aWorld oldRect oldPageNumber ascending |
	pages isEmpty ifTrue: [^ self].

	oldPageNumber _ pages indexOf: currentPage ifAbsent: [1].

	pageIndex _ pageNumber asInteger.
	pageNumber < 1 ifTrue: [pageIndex _ pages size].
	pageNumber > pages size ifTrue: [pageIndex _ 1].


	ascending _ oldPageNumber < pageIndex.
	oldPageNumber = pageIndex ifTrue: [ascending _ nil].

	(aWorld _ self world) ifNotNil:
		[self primaryHand newKeyboardFocus: nil].
	currentPage ifNotNil:
		[(oldRect _ currentPage screenRectangle) ifNotNil:
			[oldOrigin _ oldRect origin].
		currentPage fullReleaseCachedState; delete].
	currentPage _ pages at: pageIndex.
	self addMorphBack: currentPage.
	aWorld ifNotNil:
		[self world startSteppingSubmorphsOf: currentPage.
		self showPageTurningFeedbackFromOrigin: oldOrigin ascending: ascending]! !


!PianoRollScoreMorph methodsFor: 'all' stamp: 'jm 7/10/1998 14:30'!
addCustomMenuItems: aCustomMenu hand: aHandMorph

	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	aCustomMenu add: 'expand time' action: #expandTime.
	aCustomMenu add: 'contract time' action: #contractTime.
! !

!PianoRollScoreMorph methodsFor: 'all' stamp: 'jm 7/10/1998 14:37'!
contractTime

	timeScale _ timeScale / 1.5.
	lastUpdateTick _ lastUpdateTick - 1.  "force update"
	self changed.
! !

!PianoRollScoreMorph methodsFor: 'all' stamp: 'jm 7/10/1998 14:37'!
expandTime

	timeScale _ timeScale * 1.5.
	lastUpdateTick _ lastUpdateTick - 1.  "force update"
	self changed.
! !

!PianoRollScoreMorph methodsFor: 'all' stamp: 'jm 7/10/1998 14:35'!
yForMidiKey: midiKey

	^ (bounds bottom - borderWidth - 4) - (3 * (midiKey - lowestNote))
! !



