'From Squeak 2.5 of August 6, 1999 [latest update: #1538] on 11 October 1999 at 5:22:24 pm'!
"Change Set:		versionsFix-sw
Date:			11 October 1999
Author:			Scott Wallace

Several fixes relating to the use of a versions browser to revert a method to a previous version:

(1)  While you could always hit cmd-s or ENTER in the code pane to revert to that version, it seems that using the menu equivalent, 'accept', never worked in Morphic.  Now it does.

(2)  In the list-pane, an item to revert to the corresponding version is added (this has the same functionality as the former 'filein selections' item)

(3)  Another button is added to the row of optional morphic buttons, with the same functionality as the menu item in (2) above.

Thanks to Chris Norton for reporting the bugs that this update fixes."!


!ChangeList methodsFor: 'initialization-release' stamp: 'sw 10/11/1999 17:09'!
buttonRowForVersions
	| aRow aButton |
	aRow _ AlignmentMorph newRow.
	aButton _ SimpleButtonMorph new target: self.
	aButton color: Color lightBlue; borderWidth: 1; borderColor: Color blue darker.
	aRow addTransparentSpacerOfSize: (5@0).
	#(	('compare to current' 	compareToCurrentVersion
			'opens a separate window which shows the text differences between the selected version and the current version')
		('revert'	fileInSelections
			'reverts the method to the version selected')

) do:
			[:triplet |
				aButton _ aButton fullCopy.
				aButton actionSelector: triplet second.
				aButton label: triplet first.
				aButton setBalloonText: triplet third.
				aRow addMorphBack: aButton.
				aRow addTransparentSpacerOfSize: (3 @ 0)].

	aRow addMorphBack: self diffButton.
	
	^ aRow! !

!ChangeList methodsFor: 'menu actions' stamp: 'sw 10/11/1999 17:10'!
fileInSelections 
	| any |
	any _ false.
	listSelections with: changeList do: 
		[:selected :item | selected ifTrue: [any _ true. item fileIn]].
	any ifFalse:
		[self inform: 'nothing selected, so nothing done']! !

!ChangeList methodsFor: 'menu actions' stamp: 'sw 10/11/1999 17:18'!
perform: selector orSendTo: otherTarget
	"Selector was just chosen from a menu by a user.  If I can respond, then perform it on myself.  If not, send it to otherTarget, presumably the editPane from which the menu was invoked." 

	(#accept == selector) ifTrue:
		[otherTarget isMorph ifFalse: [^ self acceptFrom: otherTarget view]].
			"weird special case just for mvc changlist"

	^ super perform: selector orSendTo: otherTarget! !

!ChangeList methodsFor: 'menu actions' stamp: 'sw 10/11/1999 17:08'!
versionsMenu: aMenu

	^ aMenu labels:

'compare to current
revert to this version
toggle diffing'
	lines: #()
	selections: #(compareToCurrentVersion fileInSelections toggleDiffing )
! !


