'From Squeak2.7 of 4 January 2000 [latest update: #1761] on 11 January 2000 at 10:58:16 am'!
"Change Set:		BehaviorsDoFix-di
Date:			11 January 2000
Author:			Your Name

Fixes SystemDictionary>>allBehaviorsDo: so that it tolerates suclasses of Class that are not metaclasses.
"!


!SystemDictionary methodsFor: 'retrieving' stamp: 'di 1/9/2000 15:14'!
allBehaviorsDo: aBlock 
	"Evaluate the argument, aBlock, for each kind of Behavior in the system 
	(that is, Object and its subclasses).
	ar 7/15/1999: The code below will not enumerate any obsolete or anonymous
	behaviors for which the following should be executed:

		Smalltalk allObjectsDo:[:obj| obj isBehavior ifTrue:[aBlock value: obj]].

	but what follows is way faster than enumerating all objects."

	aBlock value: ProtoObject.
	ProtoObject allSubclassesDoGently: aBlock.		"don't bring in ImageSegments"

	"Classes outside the ProtoObject hierarchy"
	Class subclassesDo: [:aClass |
		(aClass == ProtoObject class or: [aClass isMeta not]) ifFalse:
			["Do not enumerate ProtoObject"
			"Enumerate the non-meta class and its subclasses"
			aBlock value: aClass soleInstance.
			aClass soleInstance allSubclassesDoGently: aBlock]].! !


