'From Squeak2.7 of 4 January 2000 [latest update: #1761] on 7 January 2000 at 3:41:36 pm'!
"Change Set:		SuperSpecialSendTweak
Date:			7 January 2000
Author:			Dan Ingalls

This change was requested by Ian Piumarta.

When the compiler compiles a super send of a special selector, it has to bypass the normal encodeSelector: method, since this suppresses allocation special selectors.  It used simply to call litIndex:, but this did not check for duplicates.  These changes eliminate those duplicates."!


!Encoder methodsFor: 'encoding' stamp: 'di 1/7/2000 15:24'!
sharableLitIndex: literal
	"Special access prevents multiple entries for post-allocated super send special selectors"
	| p |
	p _ literalStream originalContents indexOf: literal.
	p = 0 ifFalse: [^ p-1].
	^ self litIndex: literal
! !


!SelectorNode methodsFor: 'code generation' stamp: 'di 1/7/2000 12:32'!
size: encoder args: nArgs super: supered
	| index |
	self reserve: encoder.
	(supered not and: [code - Send < SendLimit and: [nArgs < 3]])
		ifTrue: [^1]. "short send"
	(supered and: [code < Send]) ifTrue: 
		["super special:"
		code _ self code: (encoder sharableLitIndex: key) type: 5].
	index _ code < 256 ifTrue: [code - Send] ifFalse: [code \\ 256].
	(index <= 31 and: [nArgs <= 7])
		ifTrue: [^ 2]. "medium send"
	(supered not and: [index <= 63 and: [nArgs <= 3]])
		ifTrue: [^ 2]. "new medium send"
	^ 3 "long send"! !


"Postscript:
Recompile all methods that had duplicate selectors for super send special."
	| spls lits |
spls _ (1 to: Smalltalk specialSelectorSize) collect: [:i | Smalltalk specialSelectorAt: i].
(Smalltalk allSelect: [:cm | cm sendsToSuper and: [lits _ cm literals select: [:s | spls includes: s]. 
	lits size > 1]]) do:
		[:mstr | MessageSet parse: mstr
					toClassAndSelector: [:cls :sel | cls recompile: sel from: cls]].!

