'From Squeak2.7 of 5 January 2000 [latest update: #1789] on 5 February 2000 at 6:33:48 pm'!
"Change Set:		TextMorphVeryDeepCopy-md
Date:			14 January 2000
Author:			Marcus Denker <marcus@ira.uka.de>

Bugfix for TextMorph>>veryDeepInner:

The container was not deepcopied. To
reproduce the bug:
  -> embedd a TextMorph into some other Morph
  -> fill owners shape
  -> copy with the green halo-button
"!


!TextMorph methodsFor: 'copying' stamp: 'sma 2/5/2000 18:13'!
veryDeepFixupWith: deepCopier 
	"If target and arguments fields were weakly copied, fix them here.  If 
	they were in the tree being copied, fix them up, otherwise point to the 
	originals!!"

	super veryDeepFixupWith: deepCopier.
	"Caller beware: it makes no sense to share pointers to existing predecessor and successor"
	predecessor _ deepCopier references at: predecessor ifAbsent: [].
	successor _ deepCopier references at: successor ifAbsent: []! !

!TextMorph methodsFor: 'copying' stamp: 'sma 2/5/2000 18:15'!
veryDeepInner: deepCopier 
	"Copy all of my instance variables. Some need to be not copied at all, but shared.
	Warning!!!! Every instance variable defined in this class must be handled.
	We must also implement veryDeepFixupWith:.  See DeepCopier class comment."

	super veryDeepInner: deepCopier.
	textStyle _ textStyle veryDeepCopyWith: deepCopier.
	text _ text veryDeepCopyWith: deepCopier.
	wrapFlag _ wrapFlag veryDeepCopyWith: deepCopier.
	paragraph _ paragraph veryDeepCopyWith: deepCopier.
	editor _ editor veryDeepCopyWith: deepCopier.
	container _ container veryDeepCopyWith: deepCopier.
	predecessor _ predecessor.
	successor _ successor! !


