'From Squeak2.8alpha of 12 January 2000 [latest update: #1940] on 19 March 2000 at 1:48:07 pm'!
"Change Set:		SetRotCenter
Date:			19 March 2000
Author:			Dan Ingalls

This changeSet enables the rotation center of sketchMorphs to be set independently of the forward direction.

It also keeps the direction and center handles in front of the morph after scaling and rotation interactions.
"!


!Morph methodsFor: 'menus' stamp: 'di 3/19/2000 13:41'!
addPaintingItemsTo: aMenu hand: aHandMorph
	| subMenu movies |
	subMenu _ MenuMorph new defaultTarget: self.

	subMenu add: 'repaint' action: #editDrawing.
	subMenu add: 'set rotation center' action: #setRotationCenter.
	subMenu add: 'reset forward-direction' action: #resetForwardDirection.
	subMenu add: 'set rotation style' action: #setRotationStyle.
	subMenu add: 'erase pixels of color' action: #erasePixelsOfColor:.
	subMenu add: 'recolor of pixels of color' action: #recolorPixelsOfColor:.
	movies _
		(self world rootMorphsAt: aHandMorph targetOffset)
			select: [:m | (m isKindOf: MovieMorph) or:
						[m isKindOf: SketchMorph]].
	(movies size > 1) ifTrue:
		[subMenu add: 'insert into movie' action: #insertIntoMovie:].
	aMenu add: 'painting...' subMenu: subMenu! !


!HaloMorph methodsFor: 'private' stamp: 'di 3/19/2000 13:41'!
addDirectionHandles

	| centerOfRotationHandle |
	((innerTarget isKindOf: SketchMorph) and: [innerTarget rotationStyle == #normal])
		ifTrue:
		[self addDirectionShaft.
		centerOfRotationHandle _ self
			addGraphicalHandle: #RotationCenter at: target referencePosition
				on: #mouseDown send: #prepareToTrackCenterOfRotation:with: to: self.
		centerOfRotationHandle
				on: #mouseStillDown send: #trackCenterOfRotation:with: to: self.
		centerOfRotationHandle
				on: #mouseUp send: #setCenterOfRotation:with: to: self]
! !

!HaloMorph methodsFor: 'private' stamp: 'di 3/19/2000 13:42'!
endInteraction

	| m |
	(target isInWorld not or: [owner == nil]) ifTrue: [^ self].
	[target isFlexMorph and: [target hasNoScaleOrRotation]]
		whileTrue:
			[m _ target firstSubmorph.
			target removeFlexShell.
			target _ m].
	self isInWorld ifTrue:
		["make sure handles show in front, even if flex shell added"
		self comeToFront.
		self addHandles].
! !

!HaloMorph methodsFor: 'private' stamp: 'di 3/19/2000 13:27'!
setCenterOfRotation: evt with: rotationHandle

	innerTarget setRotationCenterFromGlobalPosition:
		(Sensor cursorPoint - self world viewBox origin).
	self endInteraction
! !


!SketchMorph methodsFor: 'menu' stamp: 'di 3/19/2000 13:13'!
setRotationCenter
	| p |
	self world displayWorld.
	Cursor crossHair showWhile:
		[p _ Sensor waitButton].
	Sensor waitNoButton.
	self setRotationCenterFromGlobalPosition: p.

! !

!SketchMorph methodsFor: 'menu' stamp: 'di 3/19/2000 13:16'!
setRotationCenterFromGlobalPosition: globalPt

	| oldRotation oldScale oldSetup |
	"Neutralize all current transformations..."
	oldSetup _ self setupAngle.
	self resetForwardDirection.
	oldScale _ scalePoint.
	oldRotation _ rotationDegrees.
	scalePoint _ 1.0@1.0.
	self rotationDegrees: 0.0.

	self rotationCenter:
		(self transformFromWorld globalPointToLocal: globalPt) - bounds origin.

	"Restore all current transformations..."
	self rotationDegrees: oldRotation.
	scalePoint _ oldScale.
	self setupAngle: oldSetup.
	self topRendererOrSelf player turn: oldSetup.
	self layoutChanged.
! !


SketchMorph removeSelector: #couldSetRotationCenterFromHalo!
