'From Squeak2.8alpha of 12 January 2000 [latest update: #2040] on 27 April 2000 at 9:04:08 pm'!
"Change Set:		AutoResizeScreen
Date:			27 April 2000
Author:			Dan Ingalls

Causes both Morphic and MVC projects to resize their Display when the OS window has been resized.
"!


!Controller methodsFor: 'basic control sequence' stamp: 'di 4/27/2000 20:23'!
interActivityPause
	"if we are looping quickly, insert a short delay.  Thus if we are just doing UI stuff, we won't take up much CPU"
	| currentTime wait |
	MinActivityLapse ifNotNil: [
		lastActivityTime ifNotNil: [ 
			currentTime _ Time millisecondClockValue.
			wait _ lastActivityTime + MinActivityLapse - currentTime.
			wait > 0 ifTrue: [ 
				wait < MinActivityLapse  "big waits happen after a snapshot"
					ifTrue: [DisplayScreen checkForNewScreenSize.
							(Delay forMilliseconds: wait) wait ]. ]. ]. ].

	lastActivityTime _ Time millisecondClockValue.! !


!DisplayScreen class methodsFor: 'display box access' stamp: 'di 4/27/2000 21:02'!
checkForNewScreenSize

	Display extent = DisplayScreen actualScreenSize ifTrue: [^ self].
	DisplayScreen startUp.
	World isMorph
		ifTrue: [World restoreDisplay]
		ifFalse: [ScheduledControllers restore.
				ScheduledControllers searchForActiveController]! !


!PasteUpMorph methodsFor: 'world state' stamp: 'di 4/27/2000 21:04'!
interCyclePause: milliSecs
	"delay enough that the next interaction cycle won't happen too soon after the original; thus, if all the system is doing is polling for interaction, the overall CPU usage of Squeak will be low"
	| currentTime wait |
	currentTime _ Time millisecondClockValue.
	self lastCycleTime ifNotNil: [ 
		wait _ self lastCycleTime + milliSecs - currentTime.
		wait > 0 ifTrue: [ 
			wait < milliSecs  "big waits happen after a snapshot"
				ifTrue: [DisplayScreen checkForNewScreenSize.
						(Delay forMilliseconds: wait) wait ]. ]. ].
	self lastCycleTime: currentTime! !

