'From Squeak2.8alpha of 4 February 2000 [latest update: #2158] on 20 May 2000 at 12:27:09 pm'!
"Change Set:		074SendingChanges-dvf
Date:			18 May 2000
Author:			Daniel Vainsencher

Forget about filing out - use Celeste to directly send changesets across the net, gzipped and all. 

Warning - might slightly conflict with a recent SqC update (drop history, I think, I'm not up to date).

Prerequisites -
MIMRefactor1"!


!ChangeSet methodsFor: 'fileIn/Out' stamp: 'dvf 5/13/2000 22:53'!
mailOut
	"File out the receiver, to a file whose name is a function of the           
	 change-set name and either of the date & time or chosen to have a      
	  
	     unique numeric tag, depending on the preference                      
	    
	 'sequentialChangeSetRevertableFileNames'"
	| slips messageStrm message compressBuffer compressStream data celeste compressedStream compressedContents compressTarget |
	Celeste allInstances size = 0 ifTrue: [^ self notify: 'Can''t send stuff until you open Celeste. Sorry.'].
	celeste _ Celeste someInstance.
	self checkForConversionMethods.
	Cursor write
		showWhile: 
			["Prepare the message"
			messageStrm _ WriteStream on: (String new: 30).
			messageStrm nextPutAll: 'From: ';
			 nextPutAll: Celeste userName;
			 cr;
			 nextPutAll: 'To: squeak@cs.uiuc.edu';
			 cr;
			 nextPutAll: 'Subject: [CS] ';
			 nextPutAll: name;
			 cr;
			 nextPutAll: 'from preamble:';
			 cr;
			 cr.
			self fileOutPreambleOn: messageStrm.
			"Prepare the gzipped data"
			message _ MailMessage from: messageStrm contents.
			message _ MailMessage from: message asMultipartText.
			data _ WriteStream on: String new.
			data header.
			self fileOutPreambleOn: data.
			self fileOutOn: data.
			self fileOutPostscriptOn: data.
			data trailer.
			data _ ReadStream on: data contents.
			compressBuffer _ ByteArray new: 1000.
			compressStream _ GZipWriteStream on: (compressTarget _ WriteStream on: (compressedContents _ ByteArray new: 1000)).
			[data atEnd]
				whileFalse: [compressStream nextPutAll: (data nextInto: compressBuffer)].
			compressStream close.
			compressedStream _ ReadStream on: compressTarget contents asString.
			CelesteComposition openForCeleste: celeste initialText: (message asTextEncodingNewPart: compressedStream named: name , '.cs.gz')].
	Preferences suppressCheckForSlips ifTrue: [^ self].
	slips _ self checkForSlips.
	(slips size > 0 and: [self confirm: 'Methods in this fileOut have halts
or references to the Transcript
or other ''slips'' in them.
Would you like to browse them?'])
		ifTrue: [Smalltalk browseMessageList: slips name: 'Possible slips in ' , name]! !


!ChangeSorter methodsFor: 'changeSet menu' stamp: 'dvf 5/13/2000 23:19'!
changeSetMenu: aMenu shifted: isShifted 
	"Could be for a single or double changeSorter"
	aMenu title: 'Change Set:
' , myChangeSet name.
	isShifted ifTrue: [^ self shiftedChangeSetMenu: aMenu].
	aMenu add: 'make changes go to me' action: #newCurrent.
	aMenu addLine.
	aMenu add: 'new change set...' action: #newSet.
	aMenu add: 'find...' action: #findCngSet.
	aMenu add: 'show...' action: #chooseCngSet.
	aMenu add: 'rename change set' action: #rename.
	aMenu addLine.
	aMenu add: 'file out' action: #fileOut.
	aMenu add: 'mail to list' action: #mailOut.
	aMenu add: 'browse methods' action: #browseChangeSet.
	aMenu addLine.
	parent
		ifNotNil: 
			[aMenu add: 'copy all to other side' action: #copyAllToOther.
			aMenu add: 'submerge into other side' action: #submergeIntoOtherSide.
			aMenu add: 'subtract other side' action: #subtractOtherSide.
			aMenu addLine].
	myChangeSet hasPreamble
		ifTrue: 
			[aMenu add: 'edit preamble' action: #addPreamble.
			aMenu add: 'remove preamble' action: #removePreamble]
		ifFalse: [aMenu add: 'add preamble' action: #addPreamble].
	"aMenu add: 'edit preamble...' action: #editPreamble."
	myChangeSet hasPostscript
		ifTrue: 
			[aMenu add: 'edit postscript...' action: #editPostscript.
			aMenu add: 'remove postscript' action: #removePostscript]
		ifFalse: [aMenu add: 'add postscript...' action: #editPostscript].
	aMenu addLine.
	aMenu add: 'destroy change set' action: #remove.
	aMenu addLine.
	aMenu add: 'more...' action: #shiftedYellowButtonActivity.
	^ aMenu! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'dvf 5/13/2000 05:08'!
mailOut
	"Create a mail with a gzipped attachment holding out the current change 
	set. "
	myChangeSet mailOut.
	parent modelWakeUp! !

