'From Squeak2.8alpha of 13 January 2000 [latest update: #2220] on 29 May 2000 at 12:40:32 am'!
"Change Set:		dirShaft-sw
Date:			26 May 2000
Author:			Scott Wallace

When showing the halo for a SketchMorph, if the morph does not already have a Player associated with it, don't show the direction shaft and don't force the creation of a player just to assist in forward-direction calculations!!"!


!HaloMorph methodsFor: 'private' stamp: 'sw 5/26/2000 08:57'!
addDirectionHandles

	| centerOfRotationHandle |
	((innerTarget isKindOf: SketchMorph) and: [innerTarget rotationStyle == #normal])
		ifTrue:
		[target player ifNotNil: [self addDirectionShaft].
		centerOfRotationHandle _ self
			addGraphicalHandle: #RotationCenter at: target referencePosition
				on: #mouseDown send: #prepareToTrackCenterOfRotation:with: to: self.
		centerOfRotationHandle
				on: #mouseStillDown send: #trackCenterOfRotation:with: to: self.
		centerOfRotationHandle
				on: #mouseUp send: #setCenterOfRotation:with: to: self]
! !

!HaloMorph methodsFor: 'private' stamp: 'sw 5/26/2000 08:57'!
doRot: evt with: rotHandle
	"Update the rotation of my target if it is rotatable."

	| degrees |
	degrees _ (evt cursorPoint - (target pointInWorld: target referencePosition)) degrees.
	degrees _ degrees - angleOffset degrees.
	degrees _ degrees detentBy: 10.0 atMultiplesOf: 90.0 snap: false.
	degrees = 0.0
		ifTrue: [rotHandle color: Color lightBlue]
		ifFalse: [rotHandle color: Color blue].
	rotHandle submorphsDo:
		[:m | m color: rotHandle color makeForegroundColor].
	((innerTarget isKindOf: SketchMorph) and: [innerTarget rotationStyle == #normal]) ifTrue:
		[self removeAllHandlesBut: rotHandle.
		target player ifNotNil: [self addDirectionShaft]].

	target rotationDegrees: degrees.

	rotHandle position: evt cursorPoint - (rotHandle extent // 2).
	self layoutChanged! !


!SketchMorph methodsFor: 'menu' stamp: 'sw 5/26/2000 08:58'!
resetForwardDirection
	| existingSetup aPlayer |
	existingSetup _ self setupAngle.
	self setupAngle: 0.
	(aPlayer _ self topRendererOrSelf player) ifNotNil:
		[aPlayer turn: existingSetup negated].
	self layoutChanged.
	self changed! !

!SketchMorph methodsFor: 'menu' stamp: 'sw 5/26/2000 08:59'!
setRotationCenterFromGlobalPosition: globalPt

	| oldRotation oldScale oldSetup aPlayer |
	"Neutralize all current transformations..."
	oldSetup _ self setupAngle.
	self resetForwardDirection.
	oldScale _ scalePoint.
	oldRotation _ rotationDegrees.
	scalePoint _ 1.0@1.0.
	self rotationDegrees: 0.0.

	self rotationCenter:
		(self transformFromWorld globalPointToLocal: globalPt) - bounds origin.

	"Restore all current transformations..."
	self rotationDegrees: oldRotation.
	scalePoint _ oldScale.
	self setupAngle: oldSetup.
	(aPlayer _ self topRendererOrSelf player) ifNotNil:
		[aPlayer turn: oldSetup].
	self layoutChanged.
! !

