'From Squeak2.8alpha of 4 February 2000 [latest update: #2210] on 1 June 2000 at 1:05:48 pm'!
"Change Set:		092FileDirSearching-sim
Date:			23 May 2000
Author:			Stewart MacLean

For those of you without flash unix utilities like grep here is a simple file search mechanisim.

I've made the processing of directories and files(streams) pluggable so that you can do what you like with them."!


!FileDirectory methodsFor: 'searching' stamp: 'SIM 5/22/2000 13:25'!
searchAllFilesForAString

	"Prompt the user for a search string, and a starting directory.
	Search the contents of all files in the starting directory and it's 
	subdirectories for the search string.
	List the paths of files in which it is found on the Transcript."

	| searchString dir |

	searchString _ FillInTheBlankMorph request: 'Enter search string'.
	searchString isEmpty ifTrue: [^nil].
	Transcript cr; show: 'Searching for ', searchString printString, ' ...'.
	(dir _ PluggableFileList getFolderDialog open) ifNotNil: [
		dir 
			withAllFilesDo: [: stream | 
				(stream contentsOfEntireFile 
					includesSubstring: searchString 
					caseSensitive: false)
						ifTrue: [Transcript cr; show: stream name]]
			andDirectoriesDo: [: d |
				d pathName]].
	Transcript cr; show: 'Finished searching for ', searchString printString! !

!FileDirectory methodsFor: 'searching' stamp: 'SIM 5/22/2000 13:33'!
withAllFilesDo: fileStreamBlock andDirectoriesDo: directoryBlock

	"For the receiver and all it's subdirectories evaluate directoryBlock.
	For a read only file stream on each file within the receiver 
	and it's subdirectories evaluate fileStreamBlock."

	| todo dir |

	todo _ OrderedCollection with: self.
	[todo size > 0] whileTrue: [
		dir _ todo removeFirst.
		directoryBlock value: dir.
		dir fileNames do: [: n | 
			fileStreamBlock value: 
				(FileStream readOnlyFileNamed: (dir fullNameFor: n))].
		dir directoryNames do: [: n | 
			todo add: (dir directoryNamed: n)]]

! !

