'From Squeak2.8alpha of 4 February 2000 [latest update: #2210] on 5 June 2000 at 6:07:39 pm'!
"Change Set:		125MVCPassword-jdr
Date:			4 June 2000
Author:			Javier Diaz-Reinoso

This changeset extend the FillInTheBlank class>>requestPassword: in ScamperFixes by Bolot Kerimbaev to work in MVC.
Then changes Celeste>>popPassword to use then new method."!


!Celeste methodsFor: 'sending mail' stamp: 'jdr 6/4/2000 15:05'!
popPassword
	"Answer the password to use when retrieving mail via POP3. The password is stored in an instance variable, which disappears when you close the Celeste window."

	userPassword ifNotNil: [^ userPassword].
	userPassword _ FillInTheBlank requestPassword: 'POP password'.
	^ userPassword
! !


!FillInTheBlank class methodsFor: 'instance creation' stamp: 'jdr 6/4/2000 15:04'!
requestPassword: queryString
	| model fillInView savedArea defaultAnswer |
	"Create an instance of me whose question is queryString. Invoke it centered at the cursor, and answer the string the user accepts. Answer the empty string if the user cancels."
	"FillInTheBlank requestPassword: 'POP password'"

	Smalltalk isMorphic
		ifTrue:
			[^ FillInTheBlankMorph requestPassword: queryString].

	defaultAnswer _ ''.
	model _ self new initialize.
	model contents: defaultAnswer.
	fillInView _
		FillInTheBlankView
			requestPassword: model
			message: queryString
			centerAt: Sensor cursorPoint
			answerHeight: 40.
	savedArea _ Form fromDisplay: fillInView displayBox.
	fillInView display.
	defaultAnswer isEmpty
		ifFalse: [fillInView lastSubView controller selectFrom: 1 to: defaultAnswer size].
	(fillInView lastSubView containsPoint: Sensor cursorPoint)
		ifFalse: [fillInView lastSubView controller centerCursorInView].
	fillInView controller startUp.
	fillInView release.
	savedArea displayOn: Display at: fillInView viewport topLeft.
	^ model contents	
! !


!FillInTheBlankView class methodsFor: 'instance creation' stamp: 'jdr 6/4/2000 15:03'!
requestPassword: aFillInTheBlank message: queryString centerAt: aPoint answerHeight: answerHeight
	"Answer an instance of me on aFillInTheBlank asking the question queryString. Allow the reply to be multiple lines, and make the user input view the given height."

	| messageView answerView topView myPar pwdFont myArray myStyle |
	aFillInTheBlank acceptOnCR: true.
	messageView _ DisplayTextView new
		model: queryString asDisplayText;
		borderWidthLeft: 2 right: 2 top: 2 bottom: 0;
		controller: NoController new.
	messageView
		window: (0@0 extent: (messageView window extent max: 200@30));
		centered.
	answerView _ self new
		model: aFillInTheBlank;
		window: (0@0 extent: (messageView window width@answerHeight));
		borderWidth: 2.
	" now answerView to use the password font"
	myPar _ answerView displayContents.
	pwdFont _ (StrikeFont passwordFontSize: 12).
	myArray _ Array new: 1.
	myArray at: 1 put: pwdFont.
	myStyle _ TextStyle fontArray: myArray.
	myPar setWithText: (myPar text) style: myStyle.

	topView _ View new model: aFillInTheBlank.
	topView controller: ModalController new.
	topView addSubView: messageView.
	topView addSubView: answerView below: messageView.
	topView align: topView viewport center with: aPoint.
	topView window:
		(0 @ 0 extent:
			(messageView window width) @
			  (messageView window height + answerView window height)).
	topView translateBy:
		(topView displayBox amountToTranslateWithin: Display boundingBox).
	^ topView
! !

