'From Squeak2.9alpha of 5 August 2000 [latest update: #2485] on 14 August 2000 at 1:30:15 pm'!
"Change Set:		closeBox-sw
Date:			14 August 2000
Author:			Scott Wallace

Restores the close box to predebug notifiers in morphic.

Because hitting the close-box and pushing the Abandon button are exact synonyms, this fact is now reflected by having identical balloon help msgs for the two.  Improvements in the wording of that balloon help are invited!!  Eventually it would be preferable for there to be only one way to dismiss a predebug notifier, and it makes sense for that one way to be by an Abandon button presented directly alongside the other two choices, as is currently offered in the button row, but for now I imagine the existing Squeak community is not ready to lose the accustomed closebox on the predebug notifier."!


!Debugger methodsFor: 'initialize' stamp: 'sw 8/14/2000 13:14'!
buildMorphicNotifierLabelled: label message: messageString
	| notifyPane window contentTop extentToUse |
	window _ (PreDebugWindow labelled: label) model: self.

	contentTop _ 0.2.
	extentToUse _ 450 @ 156. "nice and wide to show plenty of the error msg"
	window addMorph: (self buttonRowForPreDebugWindow: window)
				frame: (0@0 corner: 1 @ contentTop).
	
	notifyPane _ PluggableTextMorph on: self text: nil accept: nil
		readSelection: nil menu: #debugProceedMenu:.
	notifyPane editString: (self preDebugNotifierContentsFrom: messageString);
		askBeforeDiscardingEdits: false.
	window addMorph: notifyPane frame: (0@contentTop corner: 1@1).
	"window deleteCloseBox.
		chickened out by commenting the above line out, sw 8/14/2000 12:54"
	window setBalloonTextForCloseBox.

	^ window openInWorldExtent: extentToUse! !

!Debugger methodsFor: 'initialize' stamp: 'sw 8/14/2000 13:20'!
preDebugButtonQuads

	^ #(('Proceed'		proceed 	blue 	'continue execution' )
		('Abandon'		abandon 	black 	'abandon this execution by closing this window')
		('Debug'		debug 		red 		'bring up a debugger'))! !


!PreDebugWindow methodsFor: 'as yet unclassified' stamp: 'sw 8/14/2000 13:20'!
setBalloonTextForCloseBox
	closeBox ifNotNil:
		[closeBox setBalloonText: 'abandon this execution by closing this window'].
! !

