'From Squeak 2.1 of June 30, 1998 on 11 September 1998 at 4:07:24 pm'!
"Change Set:		jhmPianoRollFix
Date:			11 September 1998
Author:			John Maloney

Fixes several performance problems that appeared when a PianoRollMorph
was placed in a book page with a flex-ed ScorePlayerMorph. There were
two problems:
  a. PianoRollMorph was propagating layout changed up to its owner every step,
     even though all the layout changes were confined to the PianoRollMorph,
     thus forcing spurious layout (and redisplay) of the owner.
  b. PasteUpMorphs, although they clip their display, were not also clipping
     damage reports to their bounds. This could cause unnecessary redisplay
     of morphs outside the page boundary."
!


!PasteUpMorph methodsFor: 'misc' stamp: 'jm 9/11/1998 09:40'!
invalidRect: damageRect
	"Clip damage reports to my bounds, since drawing is clipped to my bounds."

	owner ifNotNil: [owner invalidRect: (damageRect intersect: bounds)].
! !


!PianoRollScoreMorph methodsFor: 'all' stamp: 'jm 9/11/1998 09:33'!
fullBounds
	"Overridden to clip submorph hit detection to my bounds."

	fullBounds ifNil: [fullBounds _ bounds].
	^ bounds
! !

!PianoRollScoreMorph methodsFor: 'all' stamp: 'jm 9/11/1998 09:20'!
layoutChanged
	"Override this to avoid propagating 'layoutChanged' when just adding/removing note objects."

	fullBounds = bounds ifTrue: [^ self].
	super layoutChanged.
! !


