'From Squeak2.9alpha of 26 July 2000 [latest update: #2574] on 8 September 2000 at 8:54:06 pm'!
"Change Set:		updateViewer-sw
Date:			8 September 2000
Author:			Scott Wallace

Allows viewers in flaps to feel changes made even when the flaps are closed."!


!PasteUpMorph methodsFor: 'scripting' stamp: 'sw 9/8/2000 18:51'!
allTileScriptingElements
	"Answer a list of all the morphs that pertain to tile-scripting.  A sledge-hammer"

	| all |
	all _ self allMorphs select:
		[:s | s isTileScriptingElement].
	self closedViewerFlapTabs do:
		[:aTab | all addAll: aTab referent allTileScriptingElements].
	^ all! !

!PasteUpMorph methodsFor: 'misc' stamp: 'sw 9/8/2000 18:52'!
closedViewerFlapTabs
	"Answer all the viewer flap tabs in receiver that are closed"

	^ self submorphs select:
		[:m | (m isKindOf: ViewerFlapTab) and: [m flapShowing not]]! !


!Player methodsFor: 'misc' stamp: 'sw 9/5/2000 20:13'!
allOpenViewers
	"Answer a list of all the viewers open on the receiver.  Include viewers in closed flaps"

	| aWorld all |
	(aWorld _ self costume world) ifNil: [^ #()].
	all _ aWorld allMorphs.
	aWorld closedViewerFlapTabs do:
		[:aTab | all addAll: aTab referent allMorphs].
	^ all select:
		[:m | (m isKindOf: StandardViewer) and: [m scriptedPlayer == self]]! !


!Presenter methodsFor: 'viewer' stamp: 'sw 9/8/2000 18:53'!
updateViewer: aViewer forceToShow: aCategory
	"Update the given viewer to make sure it is in step with various possible changes in the outside world, and when reshowing it be sure it shows the given category"

	| aPlayer aPosition newViewer oldOwner wasSticky barHeight cats |
	cats _ aViewer categoriesCurrentlyShowing asOrderedCollection.
	aCategory ifNotNil: [(cats includes: aCategory) ifFalse: [cats addFirst: aCategory]].
	aPlayer _ aViewer scriptedPlayer.
	aPosition _ aViewer position.
	wasSticky _ aViewer isSticky.
	newViewer _ aViewer species new visible: false.
	barHeight _ aViewer submorphs first orientation == #vertical
		ifTrue:
			[aViewer submorphs first submorphs first height]
		ifFalse:
			[0].
	newViewer initializeFor: aPlayer barHeight: barHeight includeDismissButton: aViewer hasDismissButton showCategories: cats.
	wasSticky ifTrue: [newViewer beSticky].
	oldOwner _ aViewer owner.
	oldOwner ifNotNil:
		[oldOwner replaceSubmorph: aViewer by: newViewer].
	
	"It has happened that old readouts are still on steplist.  We may see again!!"

	newViewer position: aPosition.
	newViewer enforceTileColorPolicy.
	newViewer visible: true.
	newViewer world doIfNotNil: [:aWorld | aWorld startSteppingSubmorphsOf: newViewer].
	newViewer layoutChanged! !

PasteUpMorph removeSelector: #viewersInClosedFlaps!
