'From Squeak2.9alpha of 12 June 2000 [latest update: #2590] on 10 September 2000 at 3:36:01 pm'!
"Change Set:		IntersectsFix-ar
Date:			10 September 2000
Author:			Andreas Raab

The change set fixes Rectangle>>intersects: to report false if queried for something like
	(0@0 corner: 100@100) intersects:
		(100@100 corner: 200@200).
This behavior is consistent with the general definition of class Rectangle to not include the right and bottom border. E.g., since
	(0@0 corner: 100@100) containsPoint: 100@100.
reports false, Rectangle>>intersects: should report false for the aforementioned case. The change also results in noticable speedups in cases where some heavily changing morph is pixel-positioned right next to a static morph (due to the use of #intersects: in Canvas>>isVisible:).

The change also restores the consistency with the comment in Rectangle>>intersects: saying that the code is an optimization for some older code. Before this change set the code wasn't an optimization but rather a completely different test.

Note that it's unclear if there are clients actually relying on the old definition of intersects: - so far I haven't found any but absence of evidence is no evidence of absence, eh?!
"!


!Rectangle methodsFor: 'testing' stamp: 'ar 9/10/2000 15:29'!
intersects: aRectangle 
	"Answer whether aRectangle intersects the receiver anywhere."
	"Optimized; old code answered:
		(origin max: aRectangle origin) < (corner min: aRectangle corner)"

	| rOrigin rCorner |
	rOrigin _ aRectangle origin.
	rCorner _ aRectangle corner.
	rCorner x <= origin x	ifTrue: [^ false].
	rCorner y <= origin y	ifTrue: [^ false].
	rOrigin x >= corner x	ifTrue: [^ false].
	rOrigin y >= corner y	ifTrue: [^ false].
	^ true
! !

