'From Squeak2.9alpha of 12 June 2000 [latest update: #2622] on 17 September 2000 at 6:43:38 pm'!
"Change Set:		MenuMarkers-ar
Date:			17 September 2000
Author:			Andreas Raab

Adds simple check marks to menu entries. "!


!MenuItemMorph methodsFor: 'accessing' stamp: 'ar 9/17/2000 18:32'!
contents: aString
	^self contents: aString withMarkers: true! !

!MenuItemMorph methodsFor: 'accessing' stamp: 'ar 9/17/2000 18:36'!
contents: aString withMarkers: aBool
	"Set the menu item entry. If aBool is true, parse aString for embedded markers."
	| markerIndex marker indent |
	aBool ifFalse:[^super contents: aString].
	self removeAllMorphs. "get rid of old markers if updating"
	(aString at: 1) = $< ifFalse:[^super contents: aString].
	markerIndex _ aString indexOf: $>.
	markerIndex = 0 ifTrue:[^super contents: aString].
	marker _ (aString copyFrom: 1 to: markerIndex) asLowercase.
	(#('<on>' '<off>' '<yes>' '<no>') includes: marker) ifFalse:[^super contents: aString].
	(marker = '<on>' or:[marker = '<yes>']) 
		ifTrue:[marker _ self onImage]
		ifFalse:[marker _ self offImage].
	"Indent the string using white spaces"
	indent _ ' '.
	font _ self fontToUse.
	[ (font widthOfString: indent) < (marker width + 4) ] 
		whileTrue:[indent _ indent copyWith: Character space].
	"Set the string"
	super contents: indent, (aString copyFrom: markerIndex+1 to: aString size).
	"And set the marker"
	marker _ ImageMorph new image: marker.
	marker position: (self left) @ (self top + 2).
	self addMorphFront: marker.! !

!MenuItemMorph methodsFor: 'private' stamp: 'ar 9/17/2000 18:36'!
offImage
	"Return the form to be used for indicating an '<off>' marker"
	| form |
	form _ Form extent: (self fontToUse ascent-2) asPoint depth: 16.
	(form getCanvas)
		frameAndFillRectangle: form boundingBox fillColor: (Color gray: 0.9) 
			borderWidth: 1 borderColor: Color black.
	^form! !

!MenuItemMorph methodsFor: 'private' stamp: 'ar 9/17/2000 18:36'!
onImage
	"Return the form to be used for indicating an '<off>' marker"
	| form |
	form _ Form extent: (self fontToUse ascent-2) asPoint depth: 16.
	(form getCanvas)
		frameAndFillRectangle: form boundingBox fillColor: (Color gray: 0.8) 
			borderWidth: 1 borderColor: Color black;
		line: 0@0 to: form extent - 1 width: 1 color: Color black;
		line: 0@(form height - 1) to: (form width - 1)@0 width: 1 color: Color black.
	^form! !

