'From Squeak2.9alpha of 13 June 2000 [latest update: #2558] on 7 September 2000 at 11:29:53 am'!
"Change Set:		037-FilePackageRef-pnm
Author:			PaulMcDonough

I recently wanted to reuse FilePackage in a slightly
different way from that which was (apparently)
originally intended:  rather than a single file, I
wanted to build a package of multiple files.  In
extending the api slightly to support that, it became
necessary to refactor some of the initialization code.
 One instance variable was 100% derivable from
another, so I removed it (<packageName>).  The other
state was initialized in a not-quite-obvious place, so
I moved most of it off into an #initialize method. 
Finally, I added a method, #fullName:, to allow the
name of the package to be independent of the name of
the file it came from (since I wanted to support
multiple files).

The attached change set contains those modifications,
and probably a couple more very minor refactorings."!

Object subclass: #FilePackage
	instanceVariableNames: 'packageName fullName sourceSystem classes doIts classOrder '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-File Contents Browser'!

!FilePackage methodsFor: 'accessing' stamp: 'pnm
8/23/2000 17:10'!
fullName: aString
	fullName := aString! !

!FilePackage methodsFor: 'accessing' stamp: 'pnm
8/23/2000 17:12'!
packageName
	^FileDirectory localNameFor: self fullPackageName! !

!FilePackage methodsFor: 'initialize' stamp: 'pnm
8/23/2000 17:13'!
fromFileNamed: aName
	| stream |
	fullName := aName.
	stream := FileStream readOnlyFileNamed: aName.
	self fileInFrom: stream.! !

!FilePackage methodsFor: 'initialize' stamp: 'pnm
8/23/2000 14:48'!
initialize
	classes := Dictionary new.
	classOrder := OrderedCollection new.
	sourceSystem := ''.
	doIts := OrderedCollection new.! !

!FilePackage methodsFor: 'reading' stamp: 'pnm
8/23/2000 17:24'!
fileInFrom: aStream
	| chgRec changes |
	changes := (ChangeList new scanFile: aStream from: 0
to: aStream size) changeList.
	aStream close.
	('Processing ', self packageName) 
		displayProgressAt: Sensor cursorPoint
		from: 1
		to: changes size
		during:[:bar|
			1 to: changes size do:[:i|
				bar value: i.
				chgRec := changes at: i.
				self perform: (chgRec type copyWith: $:) asSymbol
with: chgRec.
			].
		].! !


!FilePackage class methodsFor: 'instance creation' stamp: 'pnm 8/23/2000 17:16'!
new
	^super new initialize! !

Object subclass: #FilePackage
	instanceVariableNames: 'fullName sourceSystem classes doIts classOrder '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tools-File Contents Browser'!
