'From Squeak2.8 of 13 June 2000 [latest update: #2345] on 28 June 2000 at 9:38:09 pm'!
"Change Set:		ScamperButtonRow3
Date:			28 June 2000
Author:			Chris Norton

This change set incorporates and extends Karl Ramberg's Scamper button row enhancement.

Enhancement:  I've added a History button to Karl's button row.  
Code Cleanup:  I have also spent some time cleaning up the Scamper's window creation code.  The code is the same; no functionality has been lost, but Scamper's openAsMorph method has been substantially refactored.  I'm hoping my changes make the code easier to maintain, reuse and read.  I also wrapped some file stuff in an ensure block."!


!Scamper methodsFor: 'button text' stamp: 'ccn 6/28/2000 20:36'!
backButtonText

	^'Go back to previous URL in history'! !

!Scamper methodsFor: 'button text' stamp: 'ccn 6/28/2000 20:43'!
forwardButtonText

	^'Go forward to next URL in history'! !

!Scamper methodsFor: 'button text' stamp: 'ccn 6/28/2000 21:08'!
historyButtonText

	^'Return to a recent URL in history'! !

!Scamper methodsFor: 'button text' stamp: 'ccn 6/28/2000 20:48'!
homeButtonText

	^'Go to start page'! !

!Scamper methodsFor: 'button text' stamp: 'ccn 6/28/2000 20:45'!
reloadButtonText

	^'Reload page'! !

!Scamper methodsFor: 'button text' stamp: 'ccn 6/28/2000 20:48'!
stopButtonText

	^'Stop loading page'! !

!Scamper methodsFor: 'creation' stamp: 'ccn 6/28/2000 19:52'!
openAsMorph

	^self morphicWindow openInWorld
! !

!Scamper methodsFor: 'menus' stamp: 'kfr 6/11/2000 13:33'!
editStartPage
	| win textMorph |
	Smalltalk isMorphic ifFalse: [^ self inform: 'only works for morphic currently'].

	win _ SystemWindow labelled: 'edit Bookmark page'.
	win model: self.
	textMorph _ PluggableTextMorph on: self text: #startPage  accept: #startPage:.
	win addMorph: textMorph frame: (0@0 extent: 1@1).
	win openInWorld.
	^ true! !

!Scamper methodsFor: 'menus' stamp: 'kfr 6/11/2000 13:24'!
reload
	self stopEverything.
	self jumpToUrl: currentUrl
	
! !

!Scamper methodsFor: 'start page' stamp: 'ccn 6/28/2000 21:24'!
startPage: newPage
	"fill in the contents of the user's personal start page"

	| file |
	FileDirectory default deleteFileNamed: 'StartPage.html'.
	[file _ FileStream fileNamed: 'StartPage.html'.
	file ifNil: [self error: 'could not save file'].
	file nextPutAll: newPage asString.
	] ensure: [file close].
	self changed: #startPage.
	^true! !

!Scamper methodsFor: 'window definition' stamp: 'ccn 6/28/2000 21:08'!
buttonRowPane
	"Create and return a pane of navigation buttons."

	| buttonRow |
	buttonRow _ AlignmentMorph new
		borderWidth: 0;
		inset: 0;
		hResizing: #spaceFill;
		centering: #center;
		setProperty: #clipToOwnerWidth toValue: true;
		addTransparentSpacerOfSize: (5@0).
	
	buttonRow 
		addMorphBack: (self simpleButtonNamed: 'Back' action: #back text: self backButtonText); 
		addTransparentSpacerOfSize: (5@0);
		addMorphBack: (self simpleButtonNamed: 'Forward' action: #forward text: self forwardButtonText); 
		addTransparentSpacerOfSize: (5@0);
		addMorphBack: (self simpleButtonNamed: 'History' action: #displayHistory text: self historyButtonText); 
		addTransparentSpacerOfSize: (5@0);
		addMorphBack: (self simpleButtonNamed: 'Reload' action: #reload text: self reloadButtonText); 
		addTransparentSpacerOfSize: (5@0);
		addMorphBack: (self simpleButtonNamed: 'Home' action: #visitStartPage text: self homeButtonText); 
		addTransparentSpacerOfSize: (5@0);
		addMorphBack: (self simpleButtonNamed: 'Stop!!' action: #stopEverything text: self stopButtonText); 
		addTransparentSpacerOfSize: (5@0).

	^buttonRow! !

!Scamper methodsFor: 'window definition' stamp: 'ccn 6/28/2000 20:10'!
morphicWindow
	"Create and return a Morphic window for Scamper."

	^(SystemWindow labelled: 'Scamper')
		model: self;
		setProperty: #webBrowserView toValue: true;
		addMorph: self buttonRowPane frame: (0@0 extent: 1@0.07);		"Navigation buttons"
		addMorph: self urlEditPane frame: (0@0.07 extent: 1@0.06);		"URL edit pane"
		addMorph: self webContentsPane frame: (0@0.13 extent: 1@0.81);	"The web page pane"
		addMorph: self statusPane frame: (0@0.94 extent: 1.0@0.06).		"Status pane"! !

!Scamper methodsFor: 'window definition' stamp: 'ccn 6/28/2000 20:53'!
simpleButtonNamed: buttonLabel action: selector text: balloonText
	"Create and return a simple button with Scamper as the target."

	^SimpleButtonMorph new
		label: buttonLabel;
		target: self;
		color: Color transparent;
		cornerStyle: #rounded;
		borderColor: Color black;
		actionSelector: selector;
		actWhen: #buttonUp;
		setBalloonText: balloonText;
		yourself
! !

!Scamper methodsFor: 'window definition' stamp: 'ccn 6/28/2000 21:01'!
statusPane
	"Create and return the browser status pane."

	^PluggableTextMorph on: self text: #status accept: nil! !

!Scamper methodsFor: 'window definition' stamp: 'ccn 6/28/2000 20:58'!
urlEditPane
	"Create and return the URL edit pane."

	^(PluggableTextMorph on: self text: #currentUrl accept: #jumpToAbsoluteUrl:)
		acceptOnCR: true;
		yourself! !

!Scamper methodsFor: 'window definition' stamp: 'ccn 6/28/2000 21:00'!
webContentsPane
	"Create and return the web page pane."

	^WebPageMorph
		on: self 
		bg: #backgroundColor 
		text: #formattedPage 
		readSelection: #formattedPageSelection 
		menu: #menu:shifted:! !


!Scamper reorganize!
('access' backgroundColor currentUrl defaultBackgroundColor document formattedPage formattedPageSelection labelString status status:)
('browser urls' browserUrlContents:)
('button text' backButtonText forwardButtonText historyButtonText homeButtonText reloadButtonText stopButtonText)
('change/update' changeAll: invalidateLayout)
('changing page' jumpToAbsoluteUrl: jumpToNewUrl jumpToUrl: startDownloadingMorphState: startDownloadingStateIn:url: stopEverything submitFormWithInputs:url:method: submitFormWithInputs:url:method:encoding:)
('creation' openAsMorph)
('document handling' displayDocument: displayFlashPage: displayImagePage: displayPlainTextPage: displayTextHtmlPage: processMidiPage: processUnhandledPage:)
('initialization' initialize)
('lint' hasLint lint showLint)
('menus' back displayHistory editStartPage forward inspectParseTree menu:shifted: perform:orSendTo: reload viewSource visitStartPage)
('not yet categorized' doItContext doItReceiver release)
('start page' startPage startPage:)
('stepping' step wantsSteps)
('testing' isWebBrowser)
('window definition' buttonRowPane morphicWindow simpleButtonNamed:action:text: statusPane urlEditPane webContentsPane)
!

