'From Squeak2.9BJ of 22 September 2000 [latest update: #2365] on 23 September 2000 at 11:04:20 pm'!
"Change Set:		SketchFixes-ar
Date:			23 September 2000
Author:			Andreas Raab

Fixes some issues when a player wears a different costume."!


!Morph methodsFor: 'e-toy support' stamp: 'ar 9/23/2000 22:47'!
asWearableCostume
	"Return a wearable costume for some player"
	^(SketchMorph withForm: self imageForm)! !

!Morph methodsFor: 'e-toy support' stamp: 'ar 9/23/2000 22:38'!
copyCostumeStateFrom: aMorph
	"Copy all state that should be persistant for costumes from aMorph"
	self rotationCenter: aMorph rotationCenter.
	self rotationStyle: aMorph rotationStyle.
	self referencePosition: aMorph referencePosition.
	self forwardDirection: aMorph forwardDirection.
! !

!Morph methodsFor: 'e-toy support' stamp: 'ar 9/23/2000 22:40'!
rotationStyle
	"Return the 'rotation style' of the receiver"
	^#normal! !

!Morph methodsFor: 'e-toy support' stamp: 'ar 9/23/2000 22:40'!
rotationStyle: aSymbol
	"Set the 'rotation style' of the receiver; this is ignored for non-sketches"! !


!Player methodsFor: 'costume' stamp: 'ar 9/23/2000 22:47'!
renderedCostume: aMorph
	"Make aMorph be the receiver's rendered costume; if flexing is currently in effect, make the new morph be flexed correspondingly"

	| renderedMorph known anEventHandler |
	renderedMorph _ costume renderedMorph.
	renderedMorph == aMorph ifTrue: [^ self].
	self rememberCostume: renderedMorph.
	aMorph copyCostumeStateFrom: renderedMorph.
	anEventHandler _ renderedMorph eventHandler.
	costume isFlexMorph
		ifTrue:
			[costume adjustAfter:
				[costume replaceSubmorph: renderedMorph by: aMorph]]
		ifFalse:
			[costume owner replaceSubmorph: costume by: aMorph.
			aMorph player: self.
			aMorph actorState: costume actorState.
			(known _ costume knownName) ifNotNil:
				[aMorph setNameTo: known].
			costume _ aMorph].
	aMorph eventHandler: anEventHandler! !

!Player methodsFor: 'costume' stamp: 'ar 9/23/2000 22:39'!
wearCostumeOf: anotherPlayer
	"Put on a costume similar to the one currently worn by anotherPlayer"
	self renderedCostume: anotherPlayer costume renderedMorph asWearableCostume.
! !


!SketchMorph methodsFor: 'e-toy support' stamp: 'ar 9/23/2000 22:47'!
asWearableCostume
	"Return a wearable costume for some player"
	^(SketchMorph withForm: originalForm)! !

Player removeSelector: #wearSketchCostumeResembling:!
Player removeSelector: #wearSketchCostumeWithForm:using:!
