'From Squeak2.9alpha of 12 June 2000 [latest update: #2696] on 24 September 2000 at 7:09:24 pm'!
"Change Set:		MonthMorphMod
Date:			24 September 2000
Author:			Dan Ingalls

Makes the highlighing of today more responsive, and less often needed.
"!

AlignmentMorph subclass: #MonthMorph
	instanceVariableNames: 'month todayCache tileRect model '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Demo'!

!MonthMorph methodsFor: 'initialization' stamp: 'di 9/24/2000 12:15'!
highlightToday

	todayCache _ Date today.
	self allMorphsDo:
		[:m | (m isKindOf: SimpleSwitchMorph) ifTrue:
				[(m arguments isEmpty not and: [m arguments first = todayCache])
					ifTrue: [m borderWidth: 2; borderColor: Color yellow]
					ifFalse: [m borderWidth: 1; setSwitchState: m color = m onColor]]].

! !

!MonthMorph methodsFor: 'controls' stamp: 'di 9/24/2000 12:16'!
month: aMonth
	month _ aMonth.
	model ifNotNil: [model setDate: nil fromButton: nil down: false].
	self initializeWeeks.
	self highlightToday! !

!MonthMorph methodsFor: 'stepping' stamp: 'di 9/24/2000 12:21'!
step

	(todayCache == nil or: [todayCache ~= Date today])
		ifTrue: [self highlightToday  "Only happens once a day"]! !

!MonthMorph methodsFor: 'stepping' stamp: 'di 9/24/2000 12:21'!
stepTime
	"Only time stepping matters is when you start up an image where an old date is selected"

	^ 3000  "Three seconds should be good enough response"! !

!PDA methodsFor: 'date' stamp: 'di 9/24/2000 22:23'!
setDate: aDate fromButton: aButton down: down

	dateButtonPressed ifNotNil: [dateButtonPressed setSwitchState: false].
	down ifTrue: [self selectDate: aDate.
				dateButtonPressed _ aButton]
		ifFalse: [self selectDate: nil.
				dateButtonPressed _ nil].
	self currentItem: nil.
	aButton ifNotNil: [aButton owner owner highlightToday] "hack to restore highlight for today"! !

MonthMorph removeSelector: #checkForTodayShowing!

!MonthMorph reorganize!
('initialization' highlightToday initialize initializeHeader initializeWeeks model:)
('access' month selectedDates)
('geometry' extent: minExtent)
('controls' chooseYear month: next nextYear previous previousYear startMondayOrSundayString toggleStartMonday)
('stepping' step stepTime)
('all' addCustomMenuItems:hand:)
!

Undeclared removeUnreferencedKeys!
