'From Squeak2.9alpha of 17 July 2000 [latest update: #2741] on 27 September 2000 at 5:59:07 pm'!
"Change Set:		clipCanvas
Date:			27 September 2000
Author:			Bob Arning

- ensure that the canvas used by the World is clipped to the bounds of Display so that time is not wasted drawing things that are off-screen
- nudge ProjectNavigatorMorph a little further off-screen to minimize cycles consumed redrawing"!


!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/27/2000 17:54'!
amountToShowWhenSmall

	^7	"if no part of the buttons is visible, we chew up fewer cycles"! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 9/27/2000 17:52'!
currentNavigatorVersion

	^15		"since these guys get saved, we fix them up if they are older versions"! !


!WorldState methodsFor: 'update cycle' stamp: 'RAA 9/27/2000 17:43'!
doDeferredUpdatingFor: aWorld

	| properDisplay |
        "If this platform supports deferred updates, then make my canvas be the Display (or a rectangular portion of it), set the Display to deferred update mode, and answer true. Otherwise, do nothing and answer false. One can set the class variable DisableDeferredUpdates to true to completely disable the deferred updating feature."

	PasteUpMorph disableDeferredUpdates ifTrue: [^ false].
	(Display deferUpdates: true) ifNil: [^ false].  "deferred updates not supported"

	properDisplay _ canvas notNil and: [canvas form == Display].
	aWorld == World ifTrue: [  "this world fills the entire Display"
		properDisplay ifFalse: [
			aWorld viewBox: Display boundingBox.    "do first since it may clear canvas"
			self canvas: (Display getCanvas copyClipRect: Display boundingBox).
		]
	] ifFalse: [  "this world is inside an MVC window"
		(properDisplay and: [canvas clipRect = aWorld viewBox]) ifFalse: [
			self canvas:
				(Display getCanvas copyOffset: 0@0 clipRect: aWorld viewBox)
		]
	].
	^ true
! !

