'From Squeak2.9alpha of 12 June 2000 [latest update: #2778] on 1 October 2000 at 12:07:07 pm'!
"Change Set:		DropShadowHeadingFix
Date:			1 October 2000
Author:			Dan Ingalls

Repairs the control of heading and rotation center where dropShadows are involved, in a manner that is reasonably consistent with the new heading protocols.  The main problem had been that renderedMorph, which is used by the halo to set heading, goes down through dropShadows as well as transformations, so we needed a new protocol (degreesOfFlex) to return heading back up through such a chain."!


!Morph methodsFor: 'geometry eToy' stamp: 'di 10/1/2000 11:54'!
degreesOfFlex
	"Return any rotation due to flexing"
	"NOTE: because renderedMorph, which is used by the halo to set heading, goes down through dropShadows as well as transformations, we need this method (and its other implems) to come back up through such a chain."
	^ 0.0! !

!Morph methodsFor: 'geometry eToy' stamp: 'di 10/1/2000 11:50'!
heading
	"Return the receiver's heading (in eToy terms)"
	owner ifNil: [^ self forwardDirection].
	^ self forwardDirection + owner degreesOfFlex! !


!DropShadowMorph methodsFor: 'geometry' stamp: 'di 10/1/2000 11:49'!
degreesOfFlex
	"Return any rotation due to flexing"
	owner ifNil: [^ 0.0].
	^ owner degreesOfFlex! !

!DropShadowMorph methodsFor: 'geometry' stamp: 'di 10/1/2000 11:12'!
forwardDirection
	^self renderedMorph forwardDirection! !

!DropShadowMorph methodsFor: 'geometry' stamp: 'di 10/1/2000 10:47'!
forwardDirection: degrees
	^ self renderedMorph forwardDirection: degrees! !


!TransformationMorph methodsFor: 'e-toy support' stamp: 'di 10/1/2000 11:48'!
degreesOfFlex
	"Return any rotation due to flexing"
	^ self rotationDegrees! !

