'From Squeak2.9alpha of 13 June 2000 [latest update: #2829] on 8 October 2000 at 3:50:49 pm'!
"Change Set:		MoreCleanup-ar
Date:			8 October 2000
Author:			Andreas Raab

Some more cleanup. Removes 15 methods and introduces a single generic version for all of #morphsAt: #morphsAt:addTo: #unlockedMorphsAt: #unlockedMorphsAt:addTo: and their variants.
"!


!Morph methodsFor: 'submorphs-accessing' stamp: 'ar 10/8/2000 15:40'!
morphsAt: aPoint
	"Return a collection of all morphs in this morph structure that contain the given point, possibly including the receiver itself.  The order is deepest embedding first."
	^self morphsAt: aPoint unlocked: false! !

!Morph methodsFor: 'submorphs-accessing' stamp: 'ar 10/8/2000 15:40'!
morphsAt: aPoint unlocked: aBool
	"Return a collection of all morphs in this morph structure that contain the given point, possibly including the receiver itself.  The order is deepest embedding first."
	| mList |
	mList _ WriteStream on: #().
	self morphsAt: aPoint unlocked: aBool do:[:m| mList nextPut: m].
	^mList contents! !

!Morph methodsFor: 'submorphs-accessing' stamp: 'ar 10/8/2000 15:37'!
morphsAt: aPoint unlocked: aBool do: aBlock
	"Evaluate aBlock with all the morphs starting at the receiver which appear at aPoint. If aBool is true take only visible, unlocked morphs into account."
	| tfm |
	(self fullBounds containsPoint: aPoint) ifFalse:[^self].
	(aBool and:[self isLocked or:[self visible not]]) ifTrue:[^self].
	self submorphsDo:[:m|
		tfm _ m transformedFrom: self.
		m morphsAt: (tfm globalPointToLocal: aPoint) unlocked: aBool do: aBlock].
	(self containsPoint: aPoint) ifTrue:[aBlock value: self].! !

!Morph methodsFor: 'submorphs-accessing' stamp: 'ar 10/8/2000 15:44'!
rootMorphsAt: aPoint
	"Return the list of root morphs containing the given point, excluding the receiver.
	ar 11/8/1999: Moved into morph for an incredibly ugly hack in 3D worlds"
self flag: #arNote. "check this at some point"
	^ self submorphs select:
		[:m | (m fullContainsPoint: aPoint) and: [m isLocked not]]! !

TransformMorph removeSelector: #morphsAt:addTo:!
TransformMorph removeSelector: #unlockedMorphsAt:addTo:!
ScreeningMorph removeSelector: #morphsAt:addTo:!
ScreeningMorph removeSelector: #unlockedMorphsAt:addTo:!
PasteUpMorph removeSelector: #morphsAt:addTo:!
PasteUpMorph removeSelector: #unlockedMorphsAt:addTo:!
FlashPlayerMorph removeSelector: #unlockedMorphsAt:addTo:!
MatrixTransformMorph removeSelector: #morphsAt:addTo:!
MatrixTransformMorph removeSelector: #unlockedMorphsAt:addTo:!
Morph removeSelector: #morphsAt:addTo:!
Morph removeSelector: #morphsAtGlobal:!
Morph removeSelector: #uncoveredAt:!
Morph removeSelector: #unlockedMorphsAt:!
Morph removeSelector: #unlockedMorphsAt:addTo:!
Morph removeSelector: #unlockedMorphsAtGlobal:!
