'From Squeak2.9alpha of 13 June 2000 [latest update: #2831] on 8 October 2000 at 11:45:50 pm'!
"Change Set:		BreakFocus-ar
Date:			8 October 2000
Author:			Andreas Raab

Break the current mouse focus when a morph is grabbed or attached by the hand. Put into hand morph because 99% of all clients assume to loose the focus when a hand is about to hold some morph so we'll fix the remaining 1%."!


!HandMorph methodsFor: 'grabbing/dropping' stamp: 'ar 10/8/2000 23:42'!
attachMorph: m
	"Position the center of the given morph under this hand, then grab it.
	This method is used to grab far away or newly created morphs."
	| delta |
	self releaseMouseFocus. "Break focus"
	delta _ m bounds extent // 2.
	m position: (self position - delta).
	m formerPosition: m position.
	targetOffset _ m position - self position.
	self addMorphBack: m.! !

!HandMorph methodsFor: 'grabbing/dropping' stamp: 'ar 10/8/2000 23:42'!
grabMorph: aMorph
	"Grab the given morph (i.e., add it to this hand and remove it from its current owner) without changing its position. This is used to pick up a morph under the hand's current position, versus attachMorph: which is used to pick up a morph that may not be near this hand."
	| grabbed tfm |
	self releaseMouseFocus. "Break focus"
	grabbed _ aMorph aboutToBeGrabbedBy: self.
	grabbed ifNil:[^self].
	grabbed _ grabbed topRendererOrSelf.
	tfm _ grabbed owner ifNil:[IdentityTransform new] ifNotNil:[grabbed owner grabTransform].
	grabbed _ grabbed transformedBy: tfm.
	targetOffset _ grabbed position - self position.
	self addMorphBack: grabbed.! !

