'From Squeak2.9alpha of 13 June 2000 [latest update: #2947] on 4 November 2000 at 8:56 pm'!
"Change Set:		DropFix-ar
Date:			4 November 2000
Author:			Andreas Raab

Fixes positioning morphs after a drop operation so that the new (local) position is based on the full transform from the world and not only from the hand's target offset (which is never transformed)."!


!Morph methodsFor: 'events-processing' stamp: 'ar 11/4/2000 20:55'!
handleDropMorph: anEvent
	"Handle a dropping morph."
	| aMorph localPt |
	aMorph _ anEvent contents.
	"Do a symmetric check if both morphs like each other"
	(self wantsDroppedMorph: aMorph event: anEvent) ifFalse:[^self]. "I don't want her"
	(aMorph wantsToBeDroppedInto: self) ifFalse:[^self]. "She doesn't want me"
	anEvent wasHandled: true.
	"Transform the morph into the receiver's coordinate frame. This is currently incomplete since it only takes the offset into account where it really should take the entire transform."
	localPt _ (self transformedFrom: anEvent hand world) "full transform down"
				globalPointToLocal: aMorph referencePosition.
	aMorph referencePosition: localPt.
	self acceptDroppingMorph: aMorph event: anEvent.
	aMorph justDroppedInto: self event: anEvent.
! !

