'From Squeak2.9alpha of 5 August 2000 [latest update: #3138] on 10 December 2000 at 1:30:56 pm'!
"Change Set:		awkwardJunctureFix-sw
Date:			10 December 2000
Author:			Scott Wallace

Applies a solution worked out by Dan to an awkward, long-standing problem in the smart-updating code.  The nature of the code-acceptance flow-of-control creates  the possibility of an awkward juncture in which the 'confirm first use of style' dialog can be presented to the user; if in Morphic, that dialog runs the system's event loop, and hence various tools may try to update themselves when a method has been recompiled, but the source hasn't been written, leading to various infrequent but nasty, or at least annoying problems, both in the browser in which the method was submitted and in other browsers open in the project.  These are theoretically all fixed by this update."!


!CodeHolder methodsFor: 'as yet unclassified' stamp: 'sw 11/28/2000 18:45'!
didCodeChangeElsewhere
	"Determine whether the code for the currently selected method and class has been changed somewhere else."

	| aClass aSelector aCompiledMethod |
	currentCompiledMethod ifNil: [^ false].
	(aClass _ self selectedClassOrMetaClass) ifNil: [^ false].
	(aSelector _ self selectedMessageName) ifNil: [^ false].
	^ ((aCompiledMethod _ aClass compiledMethodAt: aSelector ifAbsent: [^ false]) ~~ currentCompiledMethod) and: [aCompiledMethod last ~= 0]
	! !


!VersionsBrowser methodsFor: 'init & update' stamp: 'di 11/28/2000 01:25'!
updateListsAndCodeIn: aWindow
	| aMethod |
	aMethod _ classOfMethod compiledMethodAt: selectorOfMethod ifAbsent: [^ false].
	aMethod == currentCompiledMethod
		ifFalse:
			["Do not attempt to formulate if there is no source pointer.
			It probably means it has been recompiled, but the source hasn't been written
			(as during a display of the 'save text simply?' confirmation)."
			aMethod last ~= 0 ifTrue: [self reformulateList]].
	^ true
! !

