'From Squeak2.9BJ of 22 September 2000 [latest update: #3153] on 12 December 2000 at 5:06:39 pm'!
"Change Set:		TrashDrag-ar
Date:			12 December 2000
Author:			Andreas Raab

Allow trash cans to be dragged around. Show its contents upon double click."!


!TrashCanMorph methodsFor: 'event handling' stamp: 'ar 12/11/2000 12:14'!
doubleClick: evt
	| palette |
	palette _ self standardPalette.
	((palette notNil and: [palette isInWorld]) and: [palette hasScrapsTab])
		ifTrue:
			[palette showScrapsTab]
		ifFalse:
			[self world openScrapsBook: evt].! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'ar 12/11/2000 12:02'!
mouseDown: evt
	| paintBox |
	evt hand visible: true.
	"See if a stamp is being dropped into the trash. It is not held by the hand."
	(paintBox _ self findActivePaintBox) ifNotNil: [
		paintBox getSpecial == #stamp: ifTrue: [
			paintBox deleteCurrentStamp: evt.  "throw away stamp..."
			self primaryHand showTemporaryCursor: nil.
			^ self]].	  "... and don't open trash"
	evt hand waitForClicksOrDrag: self event: evt.
! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'ar 12/11/2000 12:13'!
mouseEnter: event
	"Present feedback for potential deletion."
	| hand firstSub |
	hand _ event hand.
	(((hand submorphCount > 0) and: [(firstSub _ hand submorphs first) ~~ self]) and:
			[self wantsDroppedMorph: firstSub event: event])
		ifTrue: 
			[Preferences soundsEnabled ifTrue: [self class playMouseEnterSound].
			hand visible: false.
			self world abandonAllHalos.
			self state: #pressed]
		ifFalse:
			[self showStampIn: hand]
! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'ar 12/11/2000 12:13'!
mouseMove: evt
	| hand firstSub |
	hand _ evt hand.
	(((hand submorphCount > 0) and: [(firstSub _ hand submorphs first) ~~ self]) and:
			[self wantsDroppedMorph: firstSub event: evt])
		ifTrue: 
			[super mouseMove: evt]
! !

!TrashCanMorph methodsFor: 'event handling' stamp: 'ar 12/11/2000 12:08'!
startDrag: evt
	evt hand grabMorph: self.! !

