'From Squeak2.9alpha of 17 July 2000 [latest update: #3240] on 9 January 2001 at 8:28:07 am'!
"Change Set:		navigatorInFlap
Date:			9 January 2001
Author:			Bob Arning

Allow Project Navigator to live in a flap.
Added red menu option to switch from horizontal to vertical orientation."!


!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 08:19'!
addButtons

	self orientedVertically ifTrue: [
		self addAColumn: (
			self makeTheButtons collect: [ :x | self inAColumn: {x}]
		)
	] ifFalse: [
		self addARow: (
			self makeTheButtons collect: [ :x | self inAColumn: {x}]
		)
	].
! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 08:15'!
addCustomMenuItems: aMenu hand: aHandMorph

	"Add further items to the menu as appropriate"

	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu 
		addUpdating: #orientationString 
		action: #toggleOrientation.
! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 07:45'!
currentNavigatorVersion

	^18		"since these guys get saved, we fix them up if they are older versions"! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 07:47'!
justDroppedInto: aMorph event: anEvent

	self setProperty: #stickToTop toValue: nil.
	self positionVertically.
	LastManualPlacement _ {self position. self valueOfProperty: #stickToTop}.
	super justDroppedInto: aMorph event: anEvent.
	self step! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 07:28'!
makeTheButtons

	^{
		self buttonPrev.
		self buttonNext.
		self buttonPublish.
		self buttonNewer.
		self buttonTell.
		self buttonFind.
		self buttonFullScreen.
		self buttonFlaps.
		self buttonShare.
		self buttonPaint.
	}
! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 08:21'!
orientationString 

	^ self orientedVertically
		ifTrue:	['<yes>vertical orientation']
		ifFalse:	['<no>vertical orientation']! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 08:18'!
orientedVertically

	^self valueOfProperty: #orientedVertically ifAbsent: [false]
! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 08:26'!
positionVertically

	| wb stickToTop |

	owner == self world ifFalse: [^self].
	wb _ self worldBounds.
	stickToTop _ self valueOfProperty: #stickToTop.
	stickToTop ifNil: [
		stickToTop _ (self top - wb top) abs < (self bottom - wb bottom) abs.
		self setProperty: #stickToTop toValue: stickToTop.
	].
	mouseInside == true ifTrue: [
		stickToTop ifTrue: [
			self top: wb top
		] ifFalse: [
			self bottom: wb bottom
		].
	] ifFalse: [
		stickToTop ifTrue: [
			self bottom: wb top + self amountToShowWhenSmall
		] ifFalse: [
			self top: wb bottom - self amountToShowWhenSmall
		].
	].

! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 08:26'!
step
	| wb lastScreenMode flapsSuppressed |

	owner ifNil: [^ self].
	(self ownerThatIsA: HandMorph) ifNotNil: [^self].
	lastScreenMode _ ScreenController lastScreenModeSelected ifNil: [false].
	flapsSuppressed _ CurrentProjectRefactoring currentFlapsSuppressed.
	((self valueOfProperty: #currentNavigatorVersion) = self currentNavigatorVersion
			and: [lastScreenMode = self inFullScreenMode
			and: [flapsSuppressed = self inFlapsSuppressedMode]]) ifFalse: [
		self setProperty: #flapsSuppressedMode toValue: flapsSuppressed.
		self setProperty: #showingFullScreenMode toValue: lastScreenMode.
		self setProperty: #currentNavigatorVersion toValue: self currentNavigatorVersion.
		self removeAllMorphs.
		self addButtons.
	].
	owner == self world ifTrue: [
		owner addMorphInLayer: self.
		wb _ self worldBounds.
		self left < wb left ifTrue: [self left: wb left].
		self right > wb right ifTrue: [self right: wb right].
		self positionVertically.
	].! !

!ProjectNavigationMorph methodsFor: 'as yet unclassified' stamp: 'RAA 1/9/2001 08:18'!
toggleOrientation

	self setProperty: #orientedVertically toValue: self orientedVertically not.
	self setProperty: #currentNavigatorVersion toValue: self currentNavigatorVersion - 1.

! !

