'From Squeak2.9alpha of 5 August 2000 [latest update: #3291] on 19 January 2001 at 7:27:50 pm'!
"Change Set:		chgSetUtils-sw
Date:			6 January 2001
Author:			Scott Wallace

Two utilities relating to change sets:
* delete changes sets numbered lower than a given integer
* create an aggregate change set that bears all the changes from all the change sets in the system.
Imposes categories on ChangeSorter class methods, which had never been organized."!


!ChangeSorter class methodsFor: 'removing' stamp: 'sw 1/6/2001 06:21'!
deleteChangeSetsNumberedLowerThan: anInteger
	"Delete all changes sets whose names start with integers smaller than anInteger"

	ChangeSorter removeChangeSetsNamedSuchThat:
		[:aName | aName first isDigit and: [aName initialIntegerOrNil < anInteger]].

	"ChangeSorter deleteChangeSetsNumberedLowerThan: (ChangeSorter highestNumberedChangeSet name initialIntegerOrNil - 500)"
! !

!ChangeSorter class methodsFor: 'services' stamp: 'sw 1/19/2001 17:06'!
buildAggregateChangeSet
	"Establish a change-set named Aggregate which bears the union of all the changes in all the existing change-sets in the system (other than any pre-existing Aggregate).  This can be useful when wishing to discover potential conflicts between a disk-resident change-set and an image.  Formerly very useful, now some of its unique contributions have been overtaken by new features"

	| aggregateChangeSet |
	aggregateChangeSet _ self existingOrNewChangeSetNamed: 'Aggregate'.
	aggregateChangeSet clear.
	(self gatherChangeSets copyWithout: aggregateChangeSet) do:
		[:aChangeSet | aggregateChangeSet assimilateAllChangesFoundIn: aChangeSet]

"ChangeSorter buildAggregateChangeSet"

	! !

ChangeSorter class removeSelector: #assuredChangeSetNamed:!

!ChangeSorter class reorganize!
('enumerating' allChangeSetNames allChangeSetsWithClass:selector: changeSetNamed: changeSetsNamedSuchThat: existingOrNewChangeSetNamed: gatherChangeSets highestNumberedChangeSet mostRecentChangeSetWithChangeForClass:selector: promoteToTop:)
('class initialization' initialize)
('adding' basicNewChangeSet: newChangeSet newChangeSet: newChangesFromStream:named:)
('removing' deleteChangeSetsNumberedLowerThan: removeChangeSet: removeChangeSetsBefore: removeChangeSetsNamedSuchThat: removeEmptyUnnamedChangeSets)
('services' browseChangeSetsWithClass:selector: buildAggregateChangeSet reorderChangeSets secondaryChangeSet)
!

