'From Squeak2.9alpha of 17 July 2000 [latest update: #3357] on 1 February 2001 at 6:10:47 pm'!
"Change Set:		psEPSvsDSC
Date:			1 February 2001
Author:			Bob Arning

Add preference for type of PostScript output for most morphs: EPS or DSC.

This is still not exactly right, but getting better.

---executable code follows"

Preferences
	addPreference: #postscriptStoredAsEPS
	category: #printing
	default:  false
	balloonHelp: 'When printing a morph as PostScript, offers the choice of (true) an EPS file suitable for incorporating in a larger job or (false) a DSC file that is a standalone file'.
!


!DSCPostscriptCanvas methodsFor: 'as yet unclassified' stamp: 'RAA 2/1/2001 17:43'!
fullDraw: aMorph

	super fullDraw: aMorph.
	(morphLevel = 0 and: [aMorph pagesHandledAutomatically not]) ifTrue: [
		target showpage.
	].! !

!DSCPostscriptCanvas methodsFor: 'as yet unclassified' stamp: 'RAA 2/1/2001 18:08'!
setupGStateForMorph: aMorph
	" position the morph on the page  "

	morphLevel == (topLevelMorph pagesHandledAutomatically ifTrue: [2] ifFalse: [1]) ifTrue:[ 
		target print: '% pageOffset'; cr.
		target translate: self pageOffset.
		self writeSetupForRect: aMorph bounds.
		target print: '% negate morph offset';cr.
		target translate: aMorph bounds origin negated.
	].
! !


!GeePrinter methodsFor: 'as yet unclassified' stamp: 'RAA 2/1/2001 17:41'!
pagesHandledAutomatically

	^true! !


!Morph methodsFor: 'menus' stamp: 'RAA 2/1/2001 15:54'!
printPSToFile
	
	self printPSToFileNamed: 'MyMorph'

! !

!Morph methodsFor: 'menus' stamp: 'RAA 2/1/2001 15:54'!
printPSToFileNamed: aString
	"Ask the user for a filename and print this morph as postscript."

	| fileName rotateFlag |
	fileName _ aString asFileName.
	fileName _ FillInTheBlank 
		request: 'File name? (".eps" will be added to end)' 
		initialAnswer: fileName.
	fileName size == 0 ifTrue: [^ self beep].
	(fileName endsWith: '.eps') ifFalse: [fileName _ fileName,'.eps'].

	rotateFlag _ ((PopUpMenu labels:
'portrait (tall)
landscape (wide)')
			startUpWithCaption: 'Choose orientation...') = 2.

	(FileStream newFileNamed: fileName)
		nextPutAll: (
			PostscriptCanvas defaultCanvasType morphAsPostscript: self rotated: rotateFlag
		); close.

! !

!Morph methodsFor: 'printing' stamp: 'RAA 2/1/2001 17:42'!
pagesHandledAutomatically

	^false! !


!BookMorph methodsFor: 'printing' stamp: 'RAA 2/1/2001 17:41'!
pagesHandledAutomatically

	^true! !


!PostscriptCanvas class methodsFor: 'configuring' stamp: 'RAA 2/1/2001 15:50'!
defaultCanvasType

	^Preferences postscriptStoredAsEPS ifTrue: [EPSCanvas] ifFalse: [DSCPostscriptCanvas]! !


!TheWorldMenu methodsFor: 'as yet unclassified' stamp: 'RAA 2/1/2001 15:55'!
printWorldOnFile
	"Ask the user for a filename and print the world as postscript."

	myWorld printPSToFileNamed: 'SqueakScreen'
! !

