'From Squeak 2.2 of Sept 23, 1998 on 4 November 1998 at 12:33:05 pm'!
"Change Set:		SelectionOfItFixes-di
Date:			2 November 1998
Author:			Dan Ingalls

Passes TextMorph selection on to ParagraphEditor in order for the various commands, such as sendersOfIt, to operate on the correct range of text.

Also includes Scott Wallace's fix for choosing 'more...' in the shifted branch of the text-pane menu (used to fall into a debugger).
"!


!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:02'!
fileItIn
	self handleEdit: [textMorph editor fileItIn]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:02'!
implementorsOfIt
	self handleEdit: [textMorph editor implementorsOfIt]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:01'!
methodNamesContainingIt
	self handleEdit: [textMorph editor methodNamesContainingIt]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:01'!
methodSourceContainingIt
	self handleEdit: [textMorph editor methodSourceContainingIt]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 16:01'!
methodStringsContainingit
	self handleEdit: [textMorph editor methodStringsContainingit]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 15:59'!
referencesToIt
	self handleEdit: [textMorph editor referencesToIt]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'di 11/2/1998 15:31'!
sendersOfIt
	self handleEdit: [textMorph editor sendersOfIt]! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'sw 11/2/1998 17:49'!
yellowButtonActivity
	"Called when the shifted-menu's 'more' item is chosen"
	| menu event |
	(menu _ self getMenu: false) ifNotNil:
		["Set up to use perform:orSendTo: for model/view dispatch"
		menu setInvokingView: self.
		event _ self primaryHand lastEvent.
		menu popUpAt: event cursorPoint event: event]! !

!PluggableTextMorph methodsFor: 'editor access' stamp: 'di 11/2/1998 15:57'!
handleEdit: editBlock
	| result |
	textMorph editor selectFrom: selectionInterval first to: selectionInterval last;
						model: model.  "For, eg, evaluateSelection"
	textMorph handleEdit: [result _ editBlock value].   "Update selection after edit"
	self scrollSelectionIntoView.
	^ result! !


