'From Squeak3.1alpha [latest update: #''Squeak3.1alpha'' of 5 February 2001 update 3911] on 9 April 2001 at 5:05:06 pm'!
"Change Set:		SWSteppingFix
Date:			9 April 2001
Author:			Dan Ingalls

Fixes a problem due to the earlier consolidation of step and stepAt:.
The model-stepping logic is now handled in stepAt: instead of step.
Also separates out the suppression of stepping for collapsed windows.
"!


!SystemWindow methodsFor: 'stepping' stamp: 'di 4/9/2001 16:45'!
wantsStepsWhenCollapsed
	"Default is not to bother updating collapsed windows"

	^ false! !


!SystemWindow methodsFor: 'stepping' stamp: 'di 4/9/2001 17:04'!
stepAt: millisecondClockValue
	"If the receiver is not collapsed, step it, after first stepping the model."

	(isCollapsed not or: [self wantsStepsWhenCollapsed]) ifTrue:
		[model ifNotNil: [model stepAt: millisecondClockValue in: self].
		super stepAt: millisecondClockValue "let player, if any, step"]

"Since this method ends up calling step, the model-stepping logic should not be duplicated there."! !

!IRCMorph methodsFor: 'stepping' stamp: 'di 4/9/2001 16:52'!
wantsStepsWhenCollapsed
	"ProcessIO regardless of whether collapsed."

	^ true! !


!PDAMorph methodsFor: 'as yet unclassified' stamp: 'di 4/9/2001 16:54'!
wantsStepsWhenCollapsed
	"Keep time up to date in title bar"

	^ true! !

SystemWindow removeSelector: #step!
