'From Squeak3.1alpha of 28 February 2001 [latest update: #4024] on 16 May 2001 at 1:43:22 am'!
"Change Set:		UpdateLessOften
Date:			16 May 2001
Author:			Andreas Raab

Make thumbnail updates for 3D objects be less often."!


!Object methodsFor: 'viewer' stamp: 'ar 5/16/2001 01:40'!
updateThresholdForGraphicInViewerTab
	"When a Viewer is open on the receiver, its tab needs some graphic to show to the user. Computing this graphic can take quite some time so we want to make the update frequency depending on how long it takes to compute the thumbnail. The threshold returned by this method defines that the viewer will update at most every 'threshold * timeItTakesToDraw' milliseconds. Thus, if the time for computing the receiver's thumbnail is 200 msecs and the the threshold is 10, the viewer will update at most every two seconds."
	^20 "seems to be a pretty good general choice"! !


!ThumbnailMorph methodsFor: 'stepping' stamp: 'ar 5/16/2001 01:41'!
stepTime 
	"Adjust my step time to the time it takes drawing my referent"
	drawTime ifNil:[^ 250].
	^(objectToView updateThresholdForGraphicInViewerTab * drawTime) max: 250.! !


!WonderlandActor methodsFor: 'eToy-support' stamp: 'ar 5/16/2001 01:40'!
updateThresholdForGraphicInViewerTab
	"When a Viewer is open on the receiver, its tab needs some graphic to show to the user. Computing this graphic can take quite some time so we want to make the update frequency depending on how long it takes to compute the thumbnail. The threshold returned by this method defines that the viewer will update at most every 'threshold * timeItTakesToDraw' milliseconds. Thus, if the time for computing the receiver's thumbnail is 200 msecs and the the threshold is 10, the viewer will update at most every two seconds."
	^100 "update almost never; computing thumbnails of 3D objects is very expensive"! !

