'From Squeak 2.2 of Sept 23, 1998 on 11 November 1998 at 12:07:31 pm'!
"Change Set:		mouseLeavingsEtc-sw
Date:			11 November 1998
Author:			Scott Wallace

(revised 4:41pm 11Nov and patched back onto server)

* Allows PasteUpMorphs to be dispatched mouseEnter and mouseLeave events,

* Takes advantage of Dan's recent fixes to the inboard scroll panes, by incorporating them into the detail panes of the new viewers -- this precludes their annoying jumping around on mouseover.

* Initializes the help message for the new inboardScrollbars.

* Improves the Preferences #doesNotUnderstand: intercept so that Preferences class won't just silently swallow messages like the one that the postscript of update 689 tried to send it."!


!HandMorph methodsFor: 'event dispatching' stamp: 'sw 11/11/1998 11:00'!
mouseOverList: evt 
	"Returns a list consisting of the topmost unlocked morph in the
	innermost frame (pasteUp), and all of its containers in that frame."
	| p roots mList mm r |
	p _ evt cursorPoint.
	roots _ self world rootMorphsAt: p.  "root morphs in world"
	"[roots size > 0 and: [roots first isPlayfieldLike]]
		whileTrue:
		[roots _ roots first rootMorphsAt: p]."  "roots in innermost frame"
	roots size > 0
		ifTrue: [mList _ roots first unlockedMorphsAt: p.
				mList size > 0 ifTrue:
					["NOTE: We really only want the top morph and all its owners"
					mm _ mList first.  r _ roots first.
					mList _ OrderedCollection new.
					[mm == r] whileFalse:
						[mList addLast: mm.
						mm _ mm owner].
					mList add: r]]
		ifFalse: [mList _ EmptyArray].
	^ mList! !


!Preferences class methodsFor: 'parameters' stamp: 'sw 11/11/1998 11:58'!
viewerEditingPaneHeight
	^ 30! !

!Preferences class methodsFor: 'preferences dictionary' stamp: 'sw 11/11/1998 11:40'!
doesNotUnderstand: aMessage
	"Look up the message selector as a flag."
	aMessage arguments size > 0 ifTrue: [^ super doesNotUnderstand: aMessage].
	^ self valueOfFlag: aMessage selector
! !

!Preferences class methodsFor: 'preferences panel' stamp: 'sw 11/11/1998 11:27'!
setHelpFor: prefName toString: aString
	HelpDictionary ifNil: [self initializeHelpMessages].
	HelpDictionary at: prefName put: aString! !


!ViewerEntry methodsFor: 'all' stamp: 'sw 11/11/1998 11:50'!
addHelpPane
	helpPane ifNotNil: [^ self].
	helpPane _ PluggableTextMorph on: self text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	helpPane extent: ((self width - 4) @ (Preferences viewerEditingPaneHeight)).
	helpPane scrollBarOnLeft: false; retractable: false.
	self addMorphBack: helpPane! !

!ViewerEntry methodsFor: 'all' stamp: 'sw 11/11/1998 11:53'!
initialize
	super initialize.
	color _ Color r: 1.0 g: 0.985 b: 0.985.
	inset _ 0! !


"Postscript:
"
Preferences setHelpFor: #inboardScrollbars toString: 'If true, then ScrollPane will place scrollbars inside on the right and will not hide them on exit'.
!

