'From Squeak 2.2 of Sept 23, 1998 on 19 November 1998 at 3:41:34 pm'!
"Change Set:		colorOfSwitches-sw
Date:			19 November 1998
Author:			Scott Wallace

Ensures that the instance/comment/class switches in any browser are of the appropriate color; prompted by the fact that the file-contents browser had greenish switches."!


!Browser methodsFor: 'initialize-release' stamp: 'sw 11/19/1998 15:38'!
buildMorphicSwitches

	| instanceSwitch commentSwitch classSwitch row aColor |

	instanceSwitch _ PluggableButtonMorph
		on: self
		getState: #instanceMessagesIndicated
		action: #indicateInstanceMessages.
	instanceSwitch
		label: 'instance';
		askBeforeChanging: true.
	commentSwitch _ PluggableButtonMorph
		on: self
		getState: #classCommentIndicated
		action: #editComment.
	commentSwitch
		label: '?' asText allBold asParagraph;
		askBeforeChanging: true;
		setBalloonText: 'class comment'.
	classSwitch _ PluggableButtonMorph
		on: self
		getState: #classMessagesIndicated
		action: #indicateClassMessages.
	classSwitch
		label: 'class';
		askBeforeChanging: true.
	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		inset: 0;
		borderColor: Color transparent;
		addMorphBack: instanceSwitch;
		addMorphBack: commentSwitch;
		addMorphBack: classSwitch.

	aColor _ Color colorFrom: self defaultBackgroundColor.
	row submorphs do:
		[:m | m color: aColor.
		m onColor: aColor darker offColor: aColor].

	^ row
! !


