'From Squeak3.1alpha of 28 February 2001 [latest update: #4312] on 4 September 2001 at 2:26:29 pm'!
"Change Set:		Fix4305
Date:			4 September 2001
Author:			Andreas Raab

Fixes a bug introduces in 4305 no longer adding the change set version numbers."!


!ChangeSet methodsFor: 'fileIn/Out' stamp: 'ar 9/4/2001 14:25'!
fileOut
	"File out the receiver, to a file whose name is a function of the change-set name and either of the date & time or chosen to have a unique numeric tag, depending on the preference 'sequentialChangeSetRevertableFileNames'"

	| file slips nameToUse |
	self checkForConversionMethods.
	nameToUse _ Preferences changeSetVersionNumbers
		ifTrue:
			[FileDirectory default nextNameFor: self name extension: 'cs']
		ifFalse:
			[(self name, FileDirectory dot, Utilities dateTimeSuffix, 
				FileDirectory dot, 'cs') asFileName].
	nameToUse size > 31 ifTrue: [^ self inform: nameToUse , ' has ' , nameToUse size asString , ' letters - too long for the Mac'].
	Cursor write showWhile:
		[[file _ FileStream newFileNamed: nameToUse.
		file header; timeStamp.
		self fileOutPreambleOn: file.
		self fileOutOn: file.
		self fileOutPostscriptOn: file.
		file trailer] ensure: [file close]].

	Preferences checkForSlips ifFalse: [^ self].

	slips _ self checkForSlips.
	(slips size > 0 and: [(PopUpMenu withCaption: 'Methods in this fileOut have halts
or references to the Transcript
or other ''slips'' in them.
Would you like to browse them?' chooseFrom: 'Ignore\Browse slips') = 2])
		ifTrue: [Smalltalk browseMessageList: slips
							name: 'Possible slips in ', name]! !

