"Change Set:		BlockCannotReturn-JW
Date:			17 May 2001
Author:			Jesse Welton

BlockCannotReturn>>defaultAction called Exception>>defaultAction through a super call, which in turn called #subclassResponsibility, resulting in an incorrect error message.  Fix: reparent BlockCannotReturn as a subclass of Error (which it really should be anyway).

ScorePlayerMorph>>showResumeButtonInTheWorld and InternalThreadNavigationMorph>>triggerActionFromPianoRoll called #addDeferredUIMessage: with a block including a return, resulting in a BlockCannotReturn error under certain conditions.  Fix: rewrite the blocks to simply fall through in these conditions."
!

Error subclass: #BlockCannotReturn
	instanceVariableNames: 'result '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Exceptions Kernel'!

!InternalThreadNavigationMorph methodsFor: 'as yet unclassified' stamp: 'JW 5/17/2001 08:05'!
triggerActionFromPianoRoll

	| proj |

	WorldState addDeferredUIMessage: [
		(self currentIndex >= listOfPages size)
			ifTrue: [1 beep]
			ifFalse: [
				currentIndex _ self currentIndex + 1.
				proj _ Project named: ((listOfPages at: currentIndex) at: 1).
				proj world setProperty: #letTheMusicPlay toValue: true.
				proj enter.
			].
	]! !


!ScorePlayerMorph methodsFor: 'layout' stamp: 'JW 5/17/2001 07:54'!
showResumeButtonInTheWorld

	| w |

	WorldState addDeferredUIMessage: [
		w _ self world.
		w ifNotNil: [
			w addMorphFront:
				(self standaloneResumeButton position: (w right - 100) @ (w top + 10)).
			scorePlayer pause.
			].
	]
! !

