'From Squeak3.2alpha of 2 October 2001 [latest update: #4537] on 22 November 2001 at 12:20:28 pm'!
"Change Set:		FlapsTweak
Date:			22 November 2001
Author:			Dan Ingalls

Fixes RealEstateAgent>>reduceByFlaps: so it works properly -- ie it uses full width screen if all shared flaps (other than 'Painting') are along the bottom.

Also includes a rewrite of Flaps sharedFlapsAlongBottom so that it is more robust with respect to future changes in the set of flaps that are shared.
"!


!Flaps class methodsFor: 'shared flaps' stamp: 'di 11/22/2001 12:17'!
sharedFlapsAlongBottom
	"Put all shared flaps (except Painting which can't be moved) along the bottom"
	"Flaps sharedFlapsAlongBottom"

	| leftX unordered ordered |
	unordered _ self globalFlapTabsIfAny asIdentitySet.
	ordered _ Array streamContents:
		[:s | #('Squeak' 'Navigator' 'Supplies' 'Widgets' 'Stack Tools' 'Tools' 'Painting') do:
			[:id | (self globalFlapTabWithID: id) ifNotNilDo:
				[:ft | unordered remove: ft.
				id = 'Painting' ifFalse: [s nextPut: ft]]]].

	"Pace off in order from right to left, setting positions"
	leftX _ Display width-15.
	ordered , unordered asArray reverseDo:
		[:ft | ft setEdge: #bottom.
		ft right: leftX - 3.  leftX _ ft left].

	"Put Nav Bar centered under tab if possible"
	(self globalFlapTabWithID: 'Navigator') ifNotNilDo:
		[:ft | ft referent left: (ft center x - (ft referent width//2) max: 0)].
	self positionNavigatorAndOtherFlapsAccordingToPreference.
! !


!RealEstateAgent class methodsFor: 'as yet unclassified' stamp: 'di 11/22/2001 11:48'!
reduceByFlaps: aScreenRect 
	"Return a rectangle that won't interfere with default shared flaps"

	Flaps sharedFlapsAllowed ifFalse: [^ aScreenRect copy].
	(Flaps globalFlapTabsIfAny allSatisfy:
			[:ft | ft flapID = 'Painting' or: [ft edgeToAdhereTo == #bottom]])
		ifTrue: [^ aScreenRect withHeight: aScreenRect height - 18]
		ifFalse: [^ aScreenRect insetBy: 18]! !

