'From Squeak3.2alpha of 3 October 2001 [latest update: #4604] on 13 December 2001 at 12:48:38 am'!
"Change Set:		outOfUES-sw
Date:			12 December 2001
Author:			Scott Wallace

Caution: standalone and plugin images require different versions of this.
Two items inspired by recent activity at UES
(1)  Because of intractable performance problems, the isOverColor test is made unavailable.  This REALLY slowed things down in a Viewer open to the tests category.
(2)  Makes the do-it receiver in a textual scriptor be the same as the 'self' referred to in the code; thus, one can evaluate Smalltalk expressions inside a scriptor and have the right 'self' pertain."!


!MethodHolder methodsFor: 'menu' stamp: 'sw 12/12/2001 21:27'!
doItReceiver
	"If there is an instance associated with me, answer it, for true mapping of self.  If not, then do what other code-bearing tools do, viz. give access to the class vars."

	(self dependents detect: [:m | m isKindOf: MethodMorph]) ifNotNilDo:
		[:mm | (mm owner isKindOf: ScriptEditorMorph) ifTrue:
			[^ mm owner playerScripted]].

	^ self selectedClass ifNil: [FakeClassPool new]! !


!Morph class methodsFor: 'scripting' stamp: 'sw 12/12/2001 23:04'!
additionsToViewerCategoryTests
	"Answer viewer additions for the 'tests' category.  Note that isOverColor is commented out owing to intractable performance problems in continuously evaluating it in a Viewer -- someone should attend to this someday."

	^#(
		#tests 
		(
			"(slot isOverColor 'whether any part of the object is over the given color' Boolean	readOnly Player seesColor: unused unused) "
			(slot isUnderMouse 'whether the object is under the current mouse position' Boolean readOnly	Player getIsUnderMouse unused unused)
			(slot colorSees	'whether the given color sees the given color' Boolean readOnly	Player color:sees:	unused	unused)
			(slot touchesA	'whether I touch something that looks like...' Boolean readOnly Player touchesA:	unused	unused)
			(slot obtrudes 'whether the object sticks out over its container''s edge' Boolean readOnly Player getObtrudes unused unused)
		)
	)
! !

"Postscript:"
Vocabulary initialize.
!

