'From Squeak3.3alpha of 12 January 2002 [latest update: #4657] on 29 January 2002 at 7:58:44 pm'!
"Change Set:		transcriptFromFlap-sw
Date:			29 January 2002
Author:			Scott Wallace

Fixes the bug that a transcript obtained from a Tools flap when not in the top project would not behave properly.  Replaces the errant Tools Flap with one that does not have the bug, provided the user has the preference governing the reinitialization of flaps set to true.  Also fixed is the less-well-known bug that an Objects Tool that was created in one project and then transferred to another via a flap would also deliver up a flawed Transcript.  (Preexisting instances of the Object Tool may however retain the flaw.)"!


!Flaps class methodsFor: 'predefined flaps' stamp: 'sw 1/29/2002 16:52'!
quadsDefiningToolsFlap
	"Answer a structure defining the default Tools flap"

	^ #(
	(Browser 				prototypicalToolWindow		'Browser'			'A Browser is a tool that allows you to view all the code of all the classes in the system')
	(TranscriptStream				openMorphicTranscript				'Transcript'			'A Transcript is a window usable for logging and debugging; browse references to #Transcript for examples of how to write to it.')
	(Workspace				prototypicalToolWindow		'Workspace'			'A Workspace is a simple window for editing text.  You can later save the contents to a file if you desire.')
	(FileList					prototypicalToolWindow		'File List'			'A File List is a tool for browsing folders and files on disks and on ftp types.')
	(DualChangeSorter		prototypicalToolWindow		'Change Sorter'		'Shows two change sets side by side')
	(SelectorBrowser			prototypicalToolWindow		'Method Finder'		'A tool for discovering methods by providing sample values for arguments and results')
	(MessageNames			prototypicalToolWindow		'Message Names'		'A tool for finding, viewing, and editing all methods whose names contain a given character sequence.')
	(Preferences			preferencesControlPanel	'Preferences'			'Allows you to control numerous options')
	(Utilities				recentSubmissionsWindow	'Recent'				'A message browser that tracks the most recently-submitted methods')
	(ProcessBrowser			prototypicalToolWindow		'Processes'			'A Process Browser shows you all the running processes')
	(Preferences			annotationEditingWindow	'Annotations'		'Allows you to specify the annotations to be shown in the annotation panes of browsers, etc.')
	(Scamper				newOpenableMorph			'Scamper'			'A web browser')
	(Celeste					newOpenableMorph			'Celeste'				'Celeste -- an EMail reader')
	(PackagePaneBrowser	prototypicalToolWindow		'Packages'			'Package Browser:  like a System Browser, except that if has extra level of categorization in the top-left pane, such that class-categories are further organized into groups called "packages"')
	(ChangeSorter			prototypicalToolWindow		'Change Set'			'A tool that allows you to view and manipulate all the code changes in a single change set')

)! !


!TranscriptStream class methodsFor: 'as yet unclassified' stamp: 'sw 1/29/2002 19:56'!
openMorphicTranscript
	"Have the current project's transcript open up as a morph"

	^ Transcript openAsMorph! !

"Postscript:"
Preferences okToReinitializeFlaps ifTrue: [Flaps replaceToolsFlap].!

