'From Squeak3.2gamma of 12 January 2002 [latest update: #4743] on 6 February 2002 at 12:23:18 pm'!
"Change Set:		FixPolyBounds-ar
Date:			6 February 2002
Author:			Andreas Raab

Juan Cires Martinez noted:
> To reproduce:
>
>  ((PolygonMorph new)
>          bounds: (0@0 extent: 100@100)) openInWorld
> A polygon appears on the upper left hand corner of the screen.  Drag to
> the center to see the droppings.  Subsequent drags don't produce the
> droppings, unless the drag starts partially outside the screen.

This fixes the problem."
!


!PolygonMorph methodsFor: 'private' stamp: 'ar 2/6/2002 12:18'!
computeBounds
	| oldBounds delta excludeHandles |
	vertices ifNil: [^ self].

	self changed.
	oldBounds _ bounds.
	self releaseCachedState.
	bounds _ self curveBounds truncated.
	self arrowForms do:
		[:f | bounds _ bounds merge: (f offset extent: f extent)].
	handles ifNotNil: [self updateHandles].

	"since we are directly updating bounds, see if any ordinary submorphs exist and move them accordingly"
	(oldBounds notNil and: [(delta _ bounds origin - oldBounds origin) ~= (0@0)]) ifTrue: [
		excludeHandles _ IdentitySet new.
		handles ifNotNil: [excludeHandles addAll: handles].
		self submorphsDo: [ :each |
			(excludeHandles includes: each) ifFalse: [
				each position: each position + delta
			].
		].
	].
	self layoutChanged.
	self changed.
! !

