'From Squeak 2.3 beta of Nov 25, 1998 on 13 December 1998 at 3:02:31 pm'!
"Change Set:		jhmAcornFixes
Date:			13 December 1998
Author:			John Maloney

Changes to support the fact that the Acorn is no longer using
little-endian BitBlt. Also includes a little utility for converting
text files into Mac format (see Utilities>convertCRtoLF:)."!

!FileDirectory class methodsFor: 'system start up' stamp: 'jm 11/25/1998 21:54'!
startUp
	"Establish the platform-specific FileDirectory subclass. Do any platform-specific startup."

	self setDefaultDirectoryFrom: Smalltalk imageName.
! !

!Utilities class methodsFor: 'miscellaneous' stamp: 'jm 11/25/1998 22:31'!
convertCRtoLF: fileName
	"Convert the given file to LF line endings. Put the result in a file with the extention '.lf'"

	| in out c justPutCR |
	in _ (FileStream oldFileNamed: fileName) binary.
	out _  (FileStream newFileNamed: fileName, '.lf') binary.
	justPutCR _ false.
	[in atEnd] whileFalse: [
		c _ in next.
		c = 10
			ifTrue: [
				out nextPut: 13.
				justPutCR _ true]
			ifFalse: [
				(justPutCR and: [c = 10]) ifFalse: [out nextPut: c].
				justPutCR _ false]].
	in close.
	out close.
! !

FileDirectory class removeSelector: #platformSpecificStartup!
AcornFileDirectory class removeSelector: #byteReverseForm:!
AcornFileDirectory class removeSelector: #platformSpecificStartup!

FileDirectory subclass: #AcornFileDirectory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Files'!
