'From Squeak3.3alpha of 12 January 2002 [latest update: #4816] on 31 March 2002 at 2:44:18 am'!
"Change Set:		listToClipboard-nk
Date:			26 March 2002
Author:			Ned Konz, Scott Wallace

Adds 'copy list to clipboard' and 'copy selection to clipboard' commands to the halo menu on PluggableListMorphs."!


!PluggableListMorph methodsFor: 'menus' stamp: 'sw 3/31/2002 02:40'!
addCustomMenuItems:  aMenu hand: aHandMorph
	"Add halo menu items to be handled by the invoking hand. The halo menu is invoked by clicking on the menu-handle of the receiver's halo."

	super addCustomMenuItems: aMenu hand: aHandMorph.
	aMenu addLine.
	aMenu add: 'list font...' target: self action: #setListFont.
	aMenu add: 'copy list to clipboard' target: self action: #copyListToClipboard.
	aMenu add: 'copy selection to clipboard' target: self action: #copySelectionToClipboard! !

!PluggableListMorph methodsFor: 'menus' stamp: 'sw 3/31/2002 02:38'!
copySelectionToClipboard
	"Copy my selected item to the clipboard as a string"

	self selection
		ifNotNil:
			[Clipboard clipboardText: self selection asString]
		ifNil:
			[self flash]! !

!PluggableListMorph methodsFor: 'menus' stamp: 'nk 3/26/2002 08:49'!
copyListToClipboard
	"Copy my items to the clipboard as a multi-line string"

	| stream |
	stream _ WriteStream on: (String new: list size * 40).
	list do: [:ea | stream nextPutAll: ea asString] separatedBy: [stream nextPut: Character cr].
	Clipboard clipboardText: stream contents! !

