'From Squeak3.3alpha of 18 January 2002 [latest update: #4938] on 4 August 2002 at 8:00:50 pm'!
"Change Set:		extrasFix-sw
Date:			4 August 2002
Author:			Scott Wallace

Fixes a bug in the logic governing when the 'put into a window' item should be offered in the extras menu."!


!Morph methodsFor: 'menus' stamp: 'sw 8/4/2002 19:59'!
adMiscExtrasTo: aMenu
	"Add a submenu of miscellaneous extra items to the menu."

	| realOwner realMorph subMenu |
	subMenu _ MenuMorph new defaultTarget: self.
	(self isWorldMorph not and: [(self renderedMorph isKindOf: SystemWindow) not])
		ifTrue: [subMenu add: 'put in a window' action: #embedInWindow].

	self isWorldMorph ifFalse:
		[subMenu add: 'adhere to edge...' action: #adhereToEdge.
		subMenu addLine].

	realOwner _ (realMorph _ self topRendererOrSelf) owner.
	(realOwner isKindOf: TextPlusPasteUpMorph) ifTrue:
		[subMenu add: 'GeeMail stuff...' subMenu: (realOwner textPlusMenuFor: realMorph)].

	self affiliatedSelector ifNotNil:
		[subMenu add: 'open a messenger' action: #openMessenger.
		subMenu balloonTextForLastItem: 'Open a Messenger on the actual method call used when the button action of this object is triggered.'.
		subMenu addLine].

	subMenu
		add: 'add mouse up action' action: #addMouseUpAction;
		add: 'remove mouse up action' action: #removeMouseUpAction;
		add: 'hand me tiles to fire this button' action: #handMeTilesToFire.
	subMenu addLine.

	subMenu defaultTarget: self topRendererOrSelf.
	subMenu add: 'draw new path' action: #definePath.
	subMenu add: 'follow existing path' action: #followPath.
	subMenu add: 'delete existing path' action: #deletePath.
	subMenu addLine.

	self addGenieMenuItems: subMenu hand: ActiveHand.

	aMenu add: 'extras...' subMenu: subMenu
! !

