'From Squeak 2.3 beta of Nov 25, 1998 on 17 December 1998 at 11:19 am'!
"Change Set:		Conveniences
Date:			17 December 1998
Author:			Dan Ingalls

This changeSet includes three minor improvments:

1.	It allows sendersOfIt and implementorsOfIt to deal with most cases of embedded parentheses.

2.	It causes printIt to paste its result in the same font as that preceding it.

3.	It supports acceptOnCR in the selectorBrowser type-in Pane (morphic only).
"!


!ParagraphEditor methodsFor: 'menu messages' stamp: 'di 12/17/1998 09:33'!
selectedSelector
	"Try to make a selector out of the current text selection.
	Incorporated Dan's code for hunting down selectors with keyword parts; while this doesn't give a true parse, in most cases it does what we want, in where it doesn't, we're none the worse for it."
	| sel possibleParens level |
	sel _  self selection string withBlanksTrimmed.
	(sel includes: $:) ifTrue:
		[possibleParens _ sel findTokens: Character separators.
		sel _ String streamContents:
			[:s | level _ 0.
			possibleParens do:
				[:token |
				(level = 0 and: [token endsWith: ':'])
					ifTrue: [s nextPutAll: token]
					ifFalse: [(token endsWith: ')') ifTrue: [level _ level-1].
							(token beginsWith: '(') ifTrue: [level _ level+1]]]]].

	sel isEmpty ifTrue: [^ nil].
	Symbol hasInterned: sel ifTrue:
		[:aSymbol | ^ aSymbol].

	^ nil! !

!ParagraphEditor methodsFor: 'new selection' stamp: 'di 12/17/1998 09:41'!
insertAndSelect: aString at: anInteger

	self replace: (anInteger to: anInteger - 1)
		with: (Text string: (' ' , aString)
					attributes: emphasisHere)
		and: [self selectAndScroll]! !


!SelectorBrowser methodsFor: 'all' stamp: 'di 12/17/1998 09:47'!
openAsMorph
	"Create a Browser that lets you type part of a selector, shows a list of selectors, shows the classes of the one you chose, and spwns a full browser on it.
	SelectorBrowser new open   "
	| window typeInView selectorListView classListView |
	window _ (SystemWindow labelled: 'later') model: self.
	selectorIndex _ classListIndex _ 0.

	typeInView _ PluggableTextMorph on: self 
		text: #contents accept: #contents:notifying:
		readSelection: #contentsSelection menu: #codePaneMenu:shifted:.
	typeInView acceptOnCR: true.
	window addMorph: typeInView frame: (0@0 corner: 0.5@0.14).

	selectorListView _ PluggableListMorph on: self
		list: #messageList
		selected: #messageListIndex
		changeSelected: #messageListIndex:
		menu: #selectorMenu:
		keystroke: #messageListKey:from:.
	selectorListView menuTitleSelector: #selectorMenuTitle.
	window addMorph: selectorListView frame: (0@0.14 corner: 0.5@1).

	classListView _ PluggableListMorph on: self
		list: #classList
		selected: #classListIndex
		changeSelected: #classListIndex:
		menu: nil
		keystroke: #arrowKey:from:.
	classListView menuTitleSelector: #classListSelectorTitle.
	window addMorph: classListView frame: (0.5@0 corner: 1@1).

	window setLabel: 'Full Browser from Selector Fragment'.
	window openInWorldExtent: 450@200! !


