'From Squeak 2.3 beta of Nov 25, 1998 on 4 January 1999 at 8:58:28 am'!

!FlashFileReader methodsFor: 'processing shapes' stamp: 'ar 1/4/1999 08:44'!
processShapesFrom: data
	"Process a new shape"
	| id bounds |
	"Read shape id and bounding box"
	id _ data nextWord.
	bounds _ data nextRect.
	"Start new shape definition"
	self recordShapeStart: id bounds: bounds.
	"Read styles for this shape"
	self processShapeStylesFrom: data.
	"Get number of bits for fill and line styles"
	data initBits.
	nFillBits _ data nextBits: 4.
	nLineBits _ data nextBits: 4.
	"Process all records in this shape definition"
	[self processShapeRecordFrom: data] whileTrue.
	"And mark the end of this shape"
	self recordShapeEnd: id.
	self recordShapeProperty: id length: data size.! !

!FlashFileReader methodsFor: 'composing shapes' stamp: 'ar 1/4/1999 08:44'!
recordShapeProperty: id length: length! !


!FlashMorph methodsFor: 'accessing' stamp: 'ar 1/4/1999 08:48'!
originalFileSize
	^(self valueOfProperty: #originalFileSize) ifNil:[0]! !

!FlashMorph methodsFor: 'menu' stamp: 'ar 1/4/1999 08:55'!
addCustomMenuItems: aCustomMenu hand: aHandMorph
	super addCustomMenuItems: aCustomMenu hand: aHandMorph.
	self defaultAALevel = nil
		ifTrue:[aCustomMenu add: 'turn on smoothing' action: #smoothingOn].
	self defaultAALevel = 2 
		ifTrue:[aCustomMenu add: 'more smoothing' action: #smoothingMore].
	self defaultAALevel = 4 
		ifTrue:[aCustomMenu add: 'turn off smoothing' action: #smoothingOff].
	aCustomMenu add:'show compressed size' action: #showCompressedSize.! !

!FlashMorph methodsFor: 'menu' stamp: 'ar 1/4/1999 08:53'!
showCompressedSize
	| size |
	size _ self originalFileSize.
	size = 0 
		ifTrue:[self inform:'Compressed size: not available']
		ifFalse:[self inform:'Compressed size: ', size asStringWithCommas, ' bytes']! !


!FlashMorphReader methodsFor: 'composing shapes' stamp: 'ar 1/4/1999 08:47'!
recordShapeProperty: id length: length
	(shapes at: id ifAbsent:[^self]) setProperty: #originalFileSize toValue: length! !


