'From Squeak3.4gamma of ''7 January 2003'' [latest update: #5170] on 26 March 2003 at 10:36:10 pm'!
"Change Set:		Lexicon>>initialLimitClass fix
Date:			26 March 2003
Author:			Chris Muller

When attempting browse protocol (p) of any class that does not inherit from Object, a doesNotUnderstand results because initialLimitClass assumes an inheritance from Object.  For example, try browing protocol of ObjectOut.

This fix selects the second-to-last superclass in the targetClass' superclass chain.  This maintains the existing selection, Object, for those that inherit from Object, and a good choice for those that don't."!


!Lexicon methodsFor: 'limit class' stamp: 'cmm 3/26/2003 22:33'!
initialLimitClass
	"Choose a plausible initial vlaue for the limit class, and answer it"

	| oneTooFar |
	limitClass _ targetClass.
	(#('ProtoObject' 'Object' 'Behavior' 'ClassDescription' 'Class' 'ProtoObject class' 'Object class') includes: targetClass name asString) ifTrue: [^ targetClass].

	oneTooFar _ (targetClass isKindOf: Metaclass)
		ifTrue:
			["use the fifth back from the superclass chain for Metaclasses, which is the immediate subclass of ProtoObject class.  Print <ProtoObject class allSuperclasses> to count them yourself."
			targetClass allSuperclasses at: (targetClass allSuperclasses size - 5)]
		ifFalse:
			[targetClass allSuperclasses at: targetClass allSuperclasses size].
	[limitClass superclass ~~ oneTooFar]
		whileTrue: [limitClass _ limitClass superclass].
	^ limitClass! !

