'From Squeak 2.3 beta of Nov 25, 1998 on 9 January 1999 at 12:00 pm'!
"Change Set:		BookSorterTweaks
Date:			9 January 1999
Author:			Dan Ingalls

Several requested tweaks to book sorters...

They shrink to a minimum size when created.

They now move the cursor (for what it's worth) when you shift-click.

They try to locate themselves below or to the right of the book.

Failing that, they appear at the lower right of the screen.
"!


!BookPageSorterMorph methodsFor: 'all' stamp: 'di 1/9/1999 11:41'!
book: aBookMorph morphsToSort: morphList

	| innerBounds |
	book _ aBookMorph.
	pageHolder removeAllMorphs.
	pageHolder addAllMorphs: morphList.
	pageHolder extent: pageHolder width@pageHolder fullBounds height.
	innerBounds _ Rectangle merging: (morphList collect: [:m | m bounds]).
	pageHolder extent: innerBounds extent + pageHolder borderWidth + 6.
	self resizeIfNeeded! !

!BookPageSorterMorph methodsFor: 'all' stamp: 'di 1/8/1999 16:27'!
forBook: aBookMorph 

	^ self book: aBookMorph
		morphsToSort: (aBookMorph pages collect: [:p | p thumbnailForPageSorter])! !

!BookPageSorterMorph methodsFor: 'all' stamp: 'di 1/9/1999 11:44'!
initialize

	super initialize.
	self extent: Display extent - 100;
		orientation: #vertical;
		centering: #topLeft;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		inset: 3;
		color: Color lightGray;
		borderWidth: 2.
	pageHolder _ PasteUpMorph new behaveLikeHolder extent: self extent - borderWidth.
	pageHolder cursor: 0.
	self addControls.
	self addMorphBack: pageHolder.
! !


!BookPageThumbnailMorph methodsFor: 'all' stamp: 'di 1/8/1999 16:38'!
doPageFlip
	"Flip to this page"

	bookMorph goToPageMorph: page
			transitionSpec: (self valueOfProperty: #transitionSpec).
	(owner isKindOf: PasteUpMorph) ifTrue:
		[owner cursor: (owner submorphs indexOf: self ifAbsent: [1])]! !


!BooklikeMorph methodsFor: 'menu commands' stamp: 'di 1/9/1999 11:52'!
sortPages
	| sorter |
	sorter _ BookPageSorterMorph new
		book: self morphsToSort: self morphsForPageSorter.
	sorter pageHolder cursor: self indexOfCurrentPage.
	"Align at bottom right of screen, but leave 20-pix margin."
	self bottom + sorter height < Display height ifTrue: "Place it below if it fits"
		[^ self world addMorphFront: (sorter align: sorter topLeft with: self bottomLeft)].
	self right + sorter width < Display width ifTrue: "Place it below if it fits"
		[^ self world addMorphFront: (sorter align: sorter bottomLeft with: self bottomRight)].
	"Otherwise, place it at lower right of screen"
	self world addMorphFront: (sorter position: Display extent - (20@20) - sorter extent).
! !


