'From Squeak 2.3 beta of Nov 25, 1998 on 10 January 1999 at 1:49:28 pm'!
"Change Set:		UI-Tweaks
Date:			10 January 1999
Author:			Dan Ingalls

Leaves the close and collapse boxes active on windows that are not on top.
This advanced feature is suppressed by the noviceMode preference.

Also restores change sorters to the 'open...' menu, as they were in 2.2.
"!


!HandMorph methodsFor: 'world menu' stamp: 'di 1/10/1999 09:49'!
openMenu
	"Build the open window menu for the world."
	| menu |
	menu _ (MenuMorph entitled: 'Open a new window') defaultTarget: self.
	menu addStayUpItem.
	menu add: 'browser' action: #openBrowser.
	menu add: 'workspace' action: #openWorkspace.
	menu add: 'file list' action: #openFileList.
	menu add: 'transcript' target: Transcript action: #open.
	menu add: 'selector finder' target: ScreenController new action: #openSelectorBrowser.
	menu addLine.
	menu add: 'simple change sorter' selector: #openChangeSorter: argument: 1.
	menu add: 'dual change sorter' selector: #openChangeSorter: argument: 2.
	menu addLine.
	menu add: 'email reader' action: #openEmail.
	menu add: 'web browser' action: #openWebBrowser.
	menu add: 'IRC chat' action: #openIRC.
	menu addLine.
	menu add: 'project (mvc)' action: #openMVCProject.
	menu add: 'project (morphic)' action: #openMorphicProject.
	menu add: 'project (construction)' action: #openConstructionProject.
	menu add: 'project link...' action: #projectThumbnail.
	^ menu
! !


!ScreenController methodsFor: 'nested menus' stamp: 'di 1/10/1999 13:43'!
openMenu
	^ SelectionMenu labelList:
		#(	'keep this menu up'

			'browser'
			'workspace'
			'file list'
			'transcript'
			'selector finder'

			'simple change sorter'
			'dual change sorter'

			'project (mvc)'
			'project (morphic)'
			'project (construction)'
			)
		lines: #(1 6 8)
		selections: #(durableOpenMenu
openBrowser openWorkspace openFileList openTranscript openSelectorBrowser
openSimpleChangeSorter openChangeManager
openProject  openMorphicProject  openConstructionProject )
"
ScreenController  new openMenu startUp
"! !


!SystemWindow methodsFor: 'top window' stamp: 'di 1/10/1999 10:15'!
passivate
	"Make me unable to respond to mouse and keyboard"
	self setStripeColorsFrom: self paneColor.
	self submorphsDo:
		[:m | (m == closeBox or: [m == collapseBox])
				ifTrue: ["Control boxes remain active, except in novice mode"
						Preferences noviceMode ifTrue: [m lock]]
				ifFalse: [m lock]].
	self world ifNotNil:
		[self world displayWorld] "clean damage now, so dont merge this rect with new top window"! !

!SystemWindow methodsFor: 'events' stamp: 'di 1/10/1999 10:10'!
handlesMouseDown: evt
	"If I am not the topWindow, then I will only respond to dragging by the title bar.
	Any other click will only bring me to the top"

	Preferences fastDragWindowForMorphic ifTrue: [^ true].
	^ self activeOnlyOnTop and: [self ~~ TopWindow]! !


