'From Squeak 2.3 beta of Nov 25, 1998 on 13 January 1999 at 12:01:03 pm'!
"Change Set:		FileBrowserTweaks
Date:			13 January 1999
Author:			Dan Ingalls

Enables command keys for the messageList pane in morphic.

Makes browseVersions work if the selected method exists in the system

Makes do-its and print-its work in the code pane.
"!


!FileContentsBrowser methodsFor: 'other' stamp: 'di 1/13/1999 09:45'!
browseVersions
	"Create and schedule a message set browser on all versions of the 
	currently selected message selector."
	| class selector |
	(selector _ self selectedMessageName) ifNotNil:
		[class _ self selectedClassOrMetaClass.
		(class exists and: [class realClass includesSelector: selector]) ifTrue:
			[ChangeList
			browseVersionsOf: (class realClass compiledMethodAt: selector)
			class: class realClass
			meta: class realClass isMeta
			category: self selectedMessageCategoryName
			selector: selector]]! !

!FileContentsBrowser methodsFor: 'creation' stamp: 'di 1/13/1999 09:32'!
openAsMorph
	"Create a pluggable version of all the views for a Browser, including views and controllers."
	| window aListExtent next |
	window _ (SystemWindow labelled: 'later') model: self.
	self packages size = 1
		ifTrue: [
			aListExtent _ 0.333333 @ 0.34.
			self systemCategoryListIndex: 1.
			window addMorph: (PluggableListMorph on: self list: #systemCategorySingleton
					selected: #indexIsOne changeSelected: #indexIsOne:
					menu: #packageListMenu:)
				frame: (0@0 extent: 1.0@0.06).
			next := 0@0.06]
		ifFalse: [
			aListExtent _ 0.25 @ 0.4.
			window addMorph: (PluggableListMorph on: self list: #systemCategoryList
					selected: #systemCategoryListIndex changeSelected: #systemCategoryListIndex:
					menu: #packageListMenu:)
				frame: (0@0 extent: aListExtent).
			next := aListExtent x @ 0].
	window addMorph: (PluggableListMorph on: self list: #classList
			selected: #classListIndex changeSelected: #classListIndex:
			menu: #classListMenu:)
		frame: (next extent: aListExtent - (0.0 @ 0.05)).
	window addMorph: self buildMorphicSwitches
		frame: (next + (0 @ (aListExtent y - 0.05)) extent: aListExtent x @ 0.05).
	next := next + (aListExtent x @ 0).
	window addMorph: (PluggableListMorph on: self list: #messageCategoryList
			selected: #messageCategoryListIndex changeSelected: #messageCategoryListIndex:
			menu: #messageCategoryMenu:)
		frame: (next extent: aListExtent).
	next := next + (aListExtent x @ 0).
	window addMorph: (PluggableListMorph on: self list: #messageList
			selected: #messageListIndex changeSelected: #messageListIndex:
			menu: #messageListMenu:
			keystroke: #messageListKey:from:)
		frame: (next extent: aListExtent).
	window addMorph: (PluggableTextMorph on: self text: #contents accept: #contents:notifying:
			readSelection: #contentsSelection menu: #codePaneMenu:shifted:)
		frame: (0@0.4 corner: 1@0.94).
	window addMorph: (PluggableTextMorph on: self text: #infoViewContents accept: nil
			readSelection: nil menu: nil)
		frame: (0@0.94 corner: 1@1).
	^ window
! !

!FileContentsBrowser methodsFor: 'menus' stamp: 'di 1/13/1999 09:47'!
messageListMenu: aMenu

	^ aMenu 
		labels:
'fileIn
fileOut
senders
implementors
versions
remove'
		lines: #(2 5)
		selections: #(fileInMessage fileOutMessage
browseSenders browseImplementors browseVersions
removeMessage).! !


!PseudoClass methodsFor: 'class' stamp: 'di 1/13/1999 12:00'!
classPool 
	self exists ifFalse: [^ nil].
	^ self realClass classPool! !

!PseudoClass methodsFor: 'class' stamp: 'di 1/13/1999 12:00'!
sharedPools 
	self exists ifFalse: [^ nil].
	^ self realClass sharedPools! !


