'From Squeak 2.3 of January 14, 1999 on 4 February 1999 at 11:30:06 pm'!
"Change Set:		ColorPickerFix
Date:			4 February 1999
Author:			Tim Olson

Fix to ColorPicker to ensure that the current selected color is really a Color, rather than an InfiniteForm, before attempting to send Color-specific messages like isTranslucentColor.  Found when setting the desktop to a pattern, then trying to setit back to a solid color."!


!ColorPickerMorph methodsFor: 'private' stamp: 'tao 2/4/1999 23:23'!
pickColorAt: aPoint 
	| worldBox globalP c alpha |
	(FeedbackBox containsPoint: aPoint - self topLeft)
		ifTrue: [^ self].
	"do nothing"
	"pick up color, either inside or outside this world"
	worldBox _ self world viewBox.
	globalP _ aPoint + worldBox topLeft.
	"get point in screen coordinates"
	(worldBox containsPoint: globalP)
		ifTrue: [c _ self world colorAt: aPoint belowMorph: Morph new]
		ifFalse: [c _ Display colorAt: globalP].
	"check for transparent color and update using appropriate feedback 
	color "
	(TransparentBox containsPoint: aPoint - self topLeft)
		ifTrue: [Display depth >= 16
				ifTrue: 
					[alpha _ (aPoint x - bounds left - 10) asFloat /
							(TransparentBox width - FeedbackBox width - 20)
							min: 1.0 max: 0.0.
					self updateColor: (selectedColor alpha: alpha)
						feedbackColor: (selectedColor alpha: alpha)]
				ifFalse: [self updateColor: Color transparent feedbackColor: Color white]]
		ifFalse: [self updateColor: ((selectedColor isColor and: [selectedColor isTranslucentColor])
					ifTrue: [c alpha: selectedColor alpha]
					ifFalse: [c])
				feedbackColor: c]! !
