'From Squeak 2.3 of January 14, 1999 on 5 March 1999 at 11:17:19 am'!

!Debugger class methodsFor: 'opening' stamp: 'tk 3/5/1999 10:57'!
openContext: aContext label: aString contents: contentsString
	"Open a notifier in response to an error, halt, or notify. A notifier view just shows a short view of the sender stack and provides a menu that lets the user open a full debugger."
	| ff |
	<primitive: 19> "Simulation guard"
	ErrorRecursion ifTrue:
		[ErrorRecursion _ false.
		self primitiveError: aString].
	Preferences logDebuggerStackToFile ifTrue:
		[FileDirectory default deleteFileNamed: 'SqueakDebug.log' ifAbsent: [].
		ff _ FileStream fileNamed: 'SqueakDebug.log'.
		ff nextPutAll: aString; cr.
  		Date today printOn: ff.  ff space.
		Time now printOn: ff.  ff cr.
		aContext stack do: [:ctxt | ff print: ctxt; cr].
		ff close].
	ErrorRecursion _ true.
	(Debugger context: aContext)
		openNotifierContents: contentsString
		label: aString.
	ErrorRecursion _ false.
	Processor activeProcess suspend.
! !

!Debugger class methodsFor: 'opening' stamp: 'tk 3/5/1999 11:17'!
openInterrupt: aString onProcess: interruptedProcess
	"Open a notifier in response to an interrupt. An interrupt occurs when the user types the interrupt key (cmd-. on Macs, ctrl-c or alt-. on other systems) or when the low-space watcher detects that memory is low."
	| debugger ff |
	<primitive: 19> "Simulation guard"
	debugger _ self new.
	debugger
		process: interruptedProcess
		controller: ((Smalltalk isMorphic not
					and: [ScheduledControllers activeControllerProcess == interruptedProcess])
						ifTrue: [ScheduledControllers activeController])
		context: interruptedProcess suspendedContext.
	debugger externalInterrupt: true.

Preferences logDebuggerStackToFile ifTrue:
	[(aString includesSubString: 'Space') & 
		(aString includesSubString: 'low') ifTrue: [
			FileDirectory default deleteFileNamed: 'LowSpaceDebug.log' ifAbsent: [].
			ff _ FileStream fileNamed: 'LowSpaceDebug.log'.
			ff nextPutAll: 'Low Space at: '.  Date today printOn: ff.  ff space.
			Time now printOn: ff.  ff cr.
			(debugger interruptedContext stackOfSize: 30) do: 
					[:ctxt | ff print: ctxt; cr].
			ff close]].

	^ debugger
		openNotifierContents: debugger interruptedContext shortStack
		label: aString
! !


