'From Squeak 2.3 of January 14, 1999 on 8 March 1999 at 10:42:28 pm'!
"Change Set:		preambleInSitu-sw
Date:			7 March 1999
Author:			Scott Wallace

A few adjustments to the Change Sorter:

(1)  The preamble is now only edited in situ in the change sorter, rather than alternatively in a separate window.  When you request 'add preamble', a preamble template shows up in the ChangeSorter's text pane.

(2)  If there already is a preamble for a change set, you can delete it via a 'remove preamble' item that replaces the 'add preamble' item in the menu.

(3)  The change-set menu in the sorter is now created by our more modern menu mechanisms rather than the awkward labels:lines:selectors of ancient days.  This finally allows the menus for both sorter variants to share the same code."!


!ChangeSet methodsFor: 'accessing' stamp: 'sw 3/5/1999 19:27'!
hasPreamble
	^ preamble notNil! !

!ChangeSet methodsFor: 'accessing' stamp: 'sw 3/5/1999 19:32'!
removePreamble
	preamble _ nil! !


!ChangeSorter methodsFor: 'changeSet menu' stamp: 'sw 3/6/1999 23:22'!
addPreamble
	myChangeSet assurePreambleExists.
	self okToChange ifTrue:
		[currentClassName _ nil.
		currentSelector _ nil.
		self showChangeSet: myChangeSet]! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'sw 3/7/1999 00:16'!
changeSetMenu: aMenu shifted: aBoolean
	"Could be for a single or double changeSorter"
	aBoolean ifTrue:
		[^ self shiftedChangeSetMenu: aMenu].

	aMenu add: 'make changes go to me' action: #newCurrent.
	aMenu addLine.
	aMenu add: 'new change set...' action: #newSet.
	aMenu add: 'find...' action: #findCngSet.
	aMenu add: 'show...' action: #chooseCngSet.
	aMenu addLine.
	aMenu add: 'file out' action: #fileOut.
	aMenu add: 'browse methods' action: #browseChangeSet.
	aMenu addLine.
	parent ifNotNil:
		[aMenu add: 'copy all to other side' action: #copyAllToOther.
		aMenu add: 'submerge into other side' action: #submergeIntoOtherSide.
		aMenu add: 'subtract other side' action: #subtractOtherSide.
		aMenu addLine].
	myChangeSet hasPreamble
		ifTrue:
			[aMenu add: 'edit preamble' action: #addPreamble.
			aMenu add: 'remove preamble' action: #removePreamble]
		ifFalse:
			[aMenu add: 'add preamble' action: #addPreamble].

	"aMenu add: 'edit preamble...' action: #editPreamble."
	aMenu add: 'edit postscript...' action: #editPostscript.
	aMenu add: 'destroy change set' action: #remove.
	aMenu addLine.
	aMenu add: 'more...' action: #shiftedYellowButtonActivity.

	^ aMenu! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'tk 4/28/1998 08:06'!
editPreamble
	"Allow the user to edit the receiver's change-set's preamble -- in a separate window."

	myChangeSet editPreamble! !

!ChangeSorter methodsFor: 'changeSet menu' stamp: 'sw 3/5/1999 19:32'!
removePreamble
	myChangeSet removePreamble.
	self showChangeSet: myChangeSet! !


