'From Squeak 2.3 of January 14, 1999 on 2 April 1999 at 3:15:56 pm'!
"Change Set:		ScamperMisc
Date:			2 April 1999
Author:			Lex Spoon

A couple of small changes to Scamper, including a fix for the
size-related bug pointed out by Mike Rutenberg:

	1. The size bug mentioned.
	2. Update the selection interval when going to a new page
	3. Change status back to 'sittin' after a page finishes downloading.
"!


!Scamper methodsFor: 'menus' stamp: 'ls 4/2/1999 15:08'!
menu: menu  shifted: shifted
	| lines selections linePositions |
	lines _ 'new URL
history
view source
inspect parse tree
go to start page
edit start page'.
	linePositions _ #(2 4).
	selections _ #(jumpToNewUrl displayHistory viewSource inspectParseTree
visitStartPage editStartPage ).

	downloadingProcess ifNotNil: [ 
		lines _ lines, String cr, 'stop downloading'.
		linePositions _ linePositions copyWith: selections size.
		selections _ selections, #(stopEverything) ].

	menu labels: lines lines: linePositions selections: selections.
	^menu.! !

!Scamper methodsFor: 'document handling' stamp: 'ls 2/5/1999 10:49'!
displayDocument: mimeDocument
	"switch to viewing the given MIMEDocument"
	|  handled  urlString |
	handled _ false.

	"add it to the history"
	recentDocuments removeAllSuchThat: [ :d | d url = mimeDocument url ].
	recentDocuments addLast: mimeDocument.
	recentDocuments size > 20 ifTrue: [ recentDocuments removeFirst ].
		
	mimeDocument mainType = 'image' 
		ifTrue: [handled _ self displayImagePage: mimeDocument].

	mimeDocument contentType = 'text/html' 
		ifTrue: [handled _ self displayTextHtmlPage: mimeDocument].

	mimeDocument contentType = 'x-application/shockwave-flash'
		ifTrue:[handled _ self displayFlashPage: mimeDocument].

	(#('audio/midi' 'audio/x-midi') includes: mimeDocument contentType) 
		ifTrue: [handled _ self processMidiPage: mimeDocument].

	"Before we display plain text files we should look at the extension of
the URL"
	(handled not and:[ mimeDocument mainType = 'text']) ifTrue:[
		urlString _ mimeDocument url toText.
		(urlString endsWithAnyOf: #('.gif' '.jpg' '.pcx')) 
			ifTrue:[handled _ self displayImagePage: mimeDocument].
		(handled not and:[urlString endsWithAnyOf: #('.mid' '.midi')])
			ifTrue:[handled _ self processMidiPage: mimeDocument].
		(handled not and:[urlString endsWith: '.swf'])
			ifTrue:[handled _ self displayFlashPage: mimeDocument].
	].

	(handled not and: [ mimeDocument mainType = 'text']) ifTrue: [
		self displayPlainTextPage: mimeDocument.
		handled _ true].


	handled ifFalse: [self processUnhandledPage: mimeDocument].

	self status: 'sittin'.! !

!Scamper methodsFor: 'document handling' stamp: 'ls 2/5/1999 09:03'!
displayPlainTextPage: newSource
	"treat as plain text"
	pageSource _ newSource content.
	document _ nil.
	formattedPage _ pageSource withSqueakLineEndings.
	currentUrl _ newSource url.

	self status: 'sittin'.
	self changeAll: 	#(currentUrl title hasLint lint formattedPage
formattedPageSelection).
	^true! !